import { Component } from 'react';
import * as React from 'react';
import { IInputProps } from '../Input/Input';
export interface IAutoCompleteProps extends IInputProps {
    /**
     * 自动补全数据源
     */
    dataSource: any[];
    /**
     * 高亮第一项
     */
    activeFirstOption?: boolean;
    /**
     * 自定义过滤函数
     */
    onFilter?: (value: any, dataSource: any[]) => string[];
}
export interface IAutoCompleteState {
    options: any[];
    show: boolean;
    active: number;
    value: any;
}
/**
 * **自动完成**-用于辅助补全输入项
 */
export declare class AutoComplete extends Component<IAutoCompleteProps, IAutoCompleteState> {
    refInput: HTMLInputElement;
    intervalHanlde: number;
    listShowTimeout: number;
    static defaultProps: {
        activeFirstOption: boolean;
        defaultValue: string;
        dataSource: never[];
    };
    state: {
        options: any[];
        show: boolean;
        active: number;
        value: string;
    };
    componentWillReceiveProps(netxProps: IAutoCompleteProps): void;
    onFocus: React.FormEventHandler<HTMLInputElement>;
    onBlur: React.FormEventHandler<HTMLInputElement>;
    onKeyDown: (e: React.KeyboardEvent<HTMLInputElement>) => void;
    onFilter: (value: string) => void;
    getValue: () => string;
    onChangeTrigger: (value: any) => void;
    hideList: () => void;
    toggleList: (show: boolean) => void;
    render(): JSX.Element;
}
export default AutoComplete;
