import * as tslib_1 from "tslib";
// tslint:disable no-any
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
import Input from '../Input';
import Transitions from '../Transitions';
import Pop from '../Pop';
var Expand = Transitions.Expand;
/**
 * **自动完成**-用于辅助补全输入项
 */
var AutoComplete = /** @class */ (function (_super) {
    tslib_1.__extends(AutoComplete, _super);
    function AutoComplete() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.intervalHanlde = 0;
        _this.listShowTimeout = 0;
        _this.state = {
            options: _this.props.dataSource,
            show: false,
            active: _this.props.activeFirstOption ? 0 : -1,
            value: _this.props.defaultValue,
        };
        _this.onFocus = function (e) {
            var onFocus = _this.props.onFocus;
            if (onFocus) {
                onFocus(e);
            }
            _this.toggleList(true);
        };
        _this.onBlur = function (e) {
            var onBlur = _this.props.onBlur;
            if (onBlur) {
                onBlur(e);
            }
            _this.hideList();
        };
        _this.onKeyDown = function (e) {
            var onKeyDown = _this.props.onKeyDown;
            if (onKeyDown) {
                onKeyDown(e);
            }
            var _a = _this.state, options = _a.options, active = _a.active;
            var keyCode = e.keyCode;
            if (keyCode === 40) {
                var next = active + 1 >= options.length ? 0 : active + 1;
                _this.setState({ active: next });
            }
            else if (keyCode === 38) {
                var pre = active - 1 < 0 ? options.length - 1 : active - 1;
                _this.setState({ active: pre });
            }
            if (keyCode === 13) {
                _this.onChangeTrigger(_this.state.options[active]);
                _this.hideList();
            }
            else {
                _this.toggleList(true);
            }
        };
        _this.onFilter = function (value) {
            var _a = _this.props, onFilter = _a.onFilter, dataSource = _a.dataSource;
            _this.onChangeTrigger(value);
            if (onFilter) {
                var options = onFilter(value, dataSource);
                _this.setState({ options: options });
            }
            else {
                var options = dataSource.filter(function (item) {
                    return String(item).match(new RegExp(value));
                });
                _this.setState({ options: options });
            }
        };
        _this.getValue = function () {
            var value = _this.props.value;
            return value !== undefined ? value : _this.state.value;
        };
        _this.onChangeTrigger = function (value) {
            var onChange = _this.props.onChange;
            if (onChange) {
                onChange(value);
            }
            _this.setState({ value: value });
        };
        // 隐藏list
        _this.hideList = function () {
            var activeFirstOption = _this.props.activeFirstOption;
            if (activeFirstOption) {
                _this.setState({ active: 0 });
            }
            _this.toggleList(false);
        };
        _this.toggleList = function (show) {
            if (_this.listShowTimeout) {
                clearTimeout(_this.listShowTimeout);
            }
            // 延时下拉框消失，否侧列表的子项click将不生效
            _this.listShowTimeout = window.setTimeout(function () {
                _this.setState({ show: show });
            }, 100);
        };
        return _this;
    }
    AutoComplete.prototype.componentWillReceiveProps = function (netxProps) {
        var _this = this;
        var dataSource = this.props.dataSource;
        var nextDataSource = netxProps.dataSource;
        if (JSON.stringify(dataSource) !== JSON.stringify(nextDataSource)) {
            this.setState({
                options: nextDataSource.filter(function (item) {
                    return String(item).match(new RegExp(_this.getValue() + ''));
                }),
            });
        }
    };
    AutoComplete.prototype.render = function () {
        var _this = this;
        var _a = this.props, className = _a.className, style = _a.style, dataSource = _a.dataSource, onFilter = _a.onFilter, value = _a.value, onChange = _a.onChange, activeFirstOption = _a.activeFirstOption, otherProps = tslib_1.__rest(_a, ["className", "style", "dataSource", "onFilter", "value", "onChange", "activeFirstOption"]);
        var preCls = 'yoshino-auto-complete';
        var clsName = classNames(preCls, className);
        var options = this.state.options;
        var inValue = this.getValue();
        var content = (React.createElement(Expand, { active: this.state.show && options.length > 0 },
            React.createElement("ul", { className: preCls + "-list" }, options.map(function (item, key) {
                var _a;
                var active = _this.state.active;
                var cls = classNames(preCls + "-item", (_a = {}, _a[preCls + "-item-active"] = key === active, _a));
                return (React.createElement("li", { className: cls, key: key, onMouseOver: function () { return _this.setState({ active: key }); }, onClick: function () {
                        _this.onChangeTrigger(item);
                        _this.hideList();
                    }, onMouseDown: function () {
                        _this.intervalHanlde = window.setInterval(function () {
                            _this.refInput.focus();
                        }, 10);
                    }, onMouseUp: function () {
                        clearInterval(_this.intervalHanlde);
                    } }, item));
            }))));
        return (React.createElement(Pop, { content: content, inheritWidth: true, placement: 'bottom', visible: true },
            React.createElement("div", { className: clsName },
                React.createElement(Input, tslib_1.__assign({}, otherProps, { onFocus: this.onFocus, onBlur: this.hideList, onKeyDown: this.onKeyDown, onChange: this.onFilter, style: style, value: inValue, refInput: function (v) {
                        if (v) {
                            _this.refInput = v;
                        }
                    } })))));
    };
    AutoComplete.defaultProps = {
        activeFirstOption: false,
        defaultValue: '',
        dataSource: [],
    };
    return AutoComplete;
}(Component));
export { AutoComplete };
export default AutoComplete;
//# sourceMappingURL=AutoComplete.js.map