import * as tslib_1 from "tslib";
import { Component, isValidElement } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
import Icon from '../Icon';
import { b as loadingSVG } from '../Loading/loadSvg';
/**
 * **按钮**-用于点击操作。
 */
var Button = /** @class */ (function (_super) {
    tslib_1.__extends(Button, _super);
    function Button() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onClick = function () {
            var _a = _this.props, loading = _a.loading, disabled = _a.disabled, onClick = _a.onClick;
            var ban = loading || disabled;
            if (ban) {
                return;
            }
            if (onClick) {
                onClick();
            }
        };
        return _this;
    }
    Button.prototype.render = function () {
        var _a;
        var _b = this.props, className = _b.className, style = _b.style, disabled = _b.disabled, type = _b.type, shape = _b.shape, size = _b.size, icon = _b.icon, ghost = _b.ghost, children = _b.children, tail = _b.tail, loading = _b.loading, onClick = _b.onClick, otherProps = tslib_1.__rest(_b, ["className", "style", "disabled", "type", "shape", "size", "icon", "ghost", "children", "tail", "loading", "onClick"]);
        var preCls = 'yoshino-button';
        var btnCls = (_a = {},
            _a[preCls + "-" + type] = type && !disabled && !loading || type === 'dashed',
            _a[preCls + "-size-" + size] = !!size,
            _a[preCls + "-ghost"] = ghost && !disabled && !loading,
            _a[preCls + "-shape-" + shape] = shape === 'circle',
            _a);
        var ban = loading || disabled;
        var iconDiv = icon ? (React.createElement("span", { className: preCls + "-icon", style: shape !== 'circle' ? tail ? { marginLeft: '5px' } : { marginRight: '5px' } : {} }, loading ? React.createElement(Icon, { className: preCls + "-load", svg: loadingSVG('1em', '1em', 'currentColor') }) :
            (isValidElement(icon) ? icon : React.createElement(Icon, { type: icon })))) : null;
        var clsName = classNames(preCls, btnCls, className);
        return (React.createElement("button", tslib_1.__assign({ className: clsName, style: style, disabled: ban, onClick: this.onClick }, otherProps),
            React.createElement("div", { className: preCls + "-container" },
                tail ? null : iconDiv,
                React.createElement("div", null, children ? loading ? 'Loading..' : children : null),
                tail ? iconDiv : null)));
    };
    Button.defaultProps = {
        ghost: false,
        loading: false,
        tail: false,
        type: 'default',
        size: 'default',
    };
    return Button;
}(Component));
export { Button };
export default Button;
//# sourceMappingURL=Button.js.map