import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
/**
 * **折叠板**-可以放缩需要展示的内容区域。
 */
var Collapse = /** @class */ (function (_super) {
    tslib_1.__extends(Collapse, _super);
    function Collapse() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            activeKeys: _this.props.defaultActiveKeys,
        };
        _this.getActiveKey = function () {
            var activeKeys = _this.props.activeKeys;
            return activeKeys === undefined ? _this.state.activeKeys : activeKeys;
        };
        _this.onChange = function (key) {
            var activeKeys = _this.getActiveKey();
            var accordion = _this.props.accordion;
            if (activeKeys.indexOf(key) !== -1) {
                activeKeys.splice(activeKeys.indexOf(key), 1);
            }
            else {
                if (accordion) {
                    activeKeys[0] = key;
                }
                else {
                    activeKeys.push(key);
                }
            }
            _this.onChangeTrigger(activeKeys);
        };
        _this.onChangeTrigger = function (activeKeys) {
            var onChange = _this.props.onChange;
            if (onChange) {
                onChange(activeKeys);
            }
            _this.setState({
                activeKeys: activeKeys,
            });
        };
        return _this;
    }
    Collapse.prototype.render = function () {
        var _this = this;
        var _a = this.props, className = _a.className, style = _a.style, children = _a.children, onChange = _a.onChange, accordion = _a.accordion, defaultActiveKeys = _a.defaultActiveKeys, otherProps = tslib_1.__rest(_a, ["className", "style", "children", "onChange", "accordion", "defaultActiveKeys"]);
        var preCls = 'yoshino-collapse';
        var clsName = classNames(preCls, className);
        var activeKeys = this.getActiveKey();
        return (React.createElement("div", tslib_1.__assign({ className: clsName, style: style }, otherProps), 
        // tslint:disable
        React.Children.map(children, function (item) {
            var key = item.props.keyId || item.key;
            return React.cloneElement(item, {
                active: activeKeys.indexOf(key) !== -1,
                onChange: _this.onChange,
                keyId: key,
            });
        })));
    };
    Collapse.defaultProps = {
        defaultActiveKeys: [],
        accordion: false,
    };
    return Collapse;
}(Component));
export { Collapse };
export default Collapse;
//# sourceMappingURL=Collapse.js.map