import { Component } from 'react';
import { IBaseComponent, TSize } from '../template/component';
interface ITimePanel {
    /**
     * 禁用时、分、秒部分选项
     */
    disabledHours?: boolean;
    disabledMinutes?: boolean;
    disabledSeconds?: boolean;
    /**
     * 展示时间格式
     */
    format?: string;
}
export interface IDatePickerProps extends IBaseComponent {
    /**
     * 默认提示文本
     */
    placeholder?: string;
    /**
     * 默认值
     */
    defaultValue?: number;
    /**
     * 值
     */
    value?: number;
    /**
     * 禁用
     */
    disabled?: boolean;
    /**
     * 值变化回调
     */
    onChange?: (v: number) => void;
    /**
     * 面板是否展开 - 受控
     */
    open?: boolean;
    /**
     * 面板是否展开 - 非受控
     */
    defaultOpen?: boolean;
    /**
     * 面板展开回调
     */
    onOpenChange?: (v: boolean) => void;
    /**
     * 尺寸
     */
    size?: TSize;
    /**
     * 展示时间格式
     */
    format?: string;
    /**
     * 是否显示时间选择器
     */
    showTime?: boolean | ITimePanel;
}
export interface IDatePickerState {
    open: boolean;
    value: number;
    showTimePicker: boolean;
}
/**
 * **组件中文名称**-组件描述。
 */
export declare class DatePicker extends Component<IDatePickerProps, IDatePickerState> {
    preCls: string;
    static defaultProps: {
        size: string;
        placeholder: string;
        defaultOpen: boolean;
        defaultValue: string;
        format: string;
    };
    state: {
        open: boolean;
        value: number;
        showTimePicker: boolean;
    };
    getOpen: () => boolean;
    getValue: () => number;
    onOpenChange: (open: boolean) => void;
    onChange: (value: number) => void;
    renderPop: () => JSX.Element;
    render(): JSX.Element;
}
export default DatePicker;
