import { Component } from 'react';
import { IBaseComponent } from '../template/component';
import Validator from './Validator';
import { IColProps } from '../Grid/Col';
import { IRowProps } from '../Grid/Row';
import * as PropTypes from 'prop-types';
export interface IFormProps extends IBaseComponent {
    onChange?: (v: any) => void;
    /**
     * label布局
     */
    labelCol?: IColProps;
    /**
     * 控件布局
     */
    wrapperCol?: IColProps;
    /**
     * 实时校验
     */
    rt?: boolean;
    row?: IRowProps;
    /**
     * 值为空时默认提示文案
     */
    requiredMsg?: string;
    /**
     * 默认值
     */
    defaultValue?: any;
}
export interface IFormState {
    value: {
        [index: string]: any;
    };
}
/**
 * **组件中文名称**-组件描述。
 */
export declare class Form extends Component<IFormProps, IFormState> {
    static Validator: typeof Validator;
    checkers: {
        [index: string]: () => boolean | string;
    };
    value: any;
    preCls: string;
    static defaultProps: {
        labelCol: {
            span: number;
        };
        wrapperCol: {
            span: number;
        };
        row: {
            align: string;
            type: string;
        };
        rt: boolean;
        requiredMsg: string;
        defaultValue: {};
    };
    static childContextTypes: {
        onChange: PropTypes.Requireable<(...args: any[]) => any>;
        onDelete: PropTypes.Requireable<(...args: any[]) => any>;
        onPushChecker: PropTypes.Requireable<(...args: any[]) => any>;
        onDeleteChecker: PropTypes.Requireable<(...args: any[]) => any>;
        row: PropTypes.Requireable<object>;
        wrapperCol: PropTypes.Requireable<object>;
        labelCol: PropTypes.Requireable<object>;
        rt: PropTypes.Requireable<boolean>;
        requiredMsg: PropTypes.Requireable<string>;
        defaultValue: PropTypes.Requireable<object>;
    };
    getChildContext(): {
        onChange: (name: string, v: any) => void;
        onDelete: (name: string) => void;
        onPushChecker: (name: string, checker: () => string | boolean) => void;
        onDeleteChecker: (name: string) => void;
        row: IRowProps | undefined;
        wrapperCol: IColProps | undefined;
        labelCol: IColProps | undefined;
        rt: boolean | undefined;
        requiredMsg: string | undefined;
        defaultValue: any;
    };
    onChange: (name: string, v: any) => void;
    onDelete: (name: string) => void;
    onPushChecker: (name: string, checker: () => string | boolean) => void;
    onDeleteChecker: (name: string) => void;
    check: () => any;
    render(): JSX.Element;
}
export default Form;
