import * as tslib_1 from "tslib";
// tslint:disable no-any
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
import Validator from './Validator';
import * as PropTypes from 'prop-types';
/**
 * **组件中文名称**-组件描述。
 */
var Form = /** @class */ (function (_super) {
    tslib_1.__extends(Form, _super);
    function Form() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.checkers = {};
        _this.value = {};
        _this.preCls = 'yoshino-form';
        _this.onChange = function (name, v) {
            var onChange = _this.props.onChange;
            _this.value[name] = v;
            if (onChange) {
                onChange(_this.value);
            }
        };
        _this.onDelete = function (name) {
            delete _this.value[name];
        };
        _this.onPushChecker = function (name, checker) {
            _this.checkers[name] = checker;
        };
        _this.onDeleteChecker = function (name) {
            delete _this.checkers[name];
        };
        _this.check = function () {
            var flag = true;
            Object.values(_this.checkers).forEach(function (check) {
                var result = check();
                if (result !== true) {
                    flag = false;
                }
            });
            if (flag) {
                return _this.value;
            }
            return flag;
        };
        return _this;
    }
    Form.prototype.getChildContext = function () {
        var _a = this.props, row = _a.row, wrapperCol = _a.wrapperCol, labelCol = _a.labelCol, rt = _a.rt, requiredMsg = _a.requiredMsg, defaultValue = _a.defaultValue;
        return {
            onChange: this.onChange,
            onDelete: this.onDelete,
            onPushChecker: this.onPushChecker,
            onDeleteChecker: this.onDeleteChecker,
            row: row,
            wrapperCol: wrapperCol,
            labelCol: labelCol,
            rt: rt,
            requiredMsg: requiredMsg,
            defaultValue: defaultValue,
        };
    };
    Form.prototype.render = function () {
        var _a = this.props, className = _a.className, style = _a.style, children = _a.children, rt = _a.rt, requiredMsg = _a.requiredMsg, onChange = _a.onChange, row = _a.row, wrapperCol = _a.wrapperCol, labelCol = _a.labelCol, otherProps = tslib_1.__rest(_a, ["className", "style", "children", "rt", "requiredMsg", "onChange", "row", "wrapperCol", "labelCol"]);
        var preCls = this.preCls;
        var clsName = classNames(preCls, className);
        return (React.createElement("div", tslib_1.__assign({ className: clsName, style: style }, otherProps), children));
    };
    Form.Validator = Validator;
    Form.defaultProps = {
        labelCol: {
            span: 8,
        },
        wrapperCol: {
            span: 16,
        },
        row: {
            align: 'middle',
            type: 'flex',
        },
        rt: false,
        requiredMsg: '${name}不能为空',
        defaultValue: {},
    };
    Form.childContextTypes = {
        onChange: PropTypes.func,
        onDelete: PropTypes.func,
        onPushChecker: PropTypes.func,
        onDeleteChecker: PropTypes.func,
        row: PropTypes.object,
        wrapperCol: PropTypes.object,
        labelCol: PropTypes.object,
        rt: PropTypes.bool,
        requiredMsg: PropTypes.string,
        defaultValue: PropTypes.object,
    };
    return Form;
}(Component));
export { Form };
export default Form;
//# sourceMappingURL=Form.js.map