import { Component } from 'react';
import * as React from 'react';
import { IBaseComponent } from '../template/component';
import { IColProps } from '../Grid/Col';
import { IRowProps } from '../Grid/Row';
import * as PropTypes from 'prop-types';
export interface IValidatorProps extends IBaseComponent {
    /**
     * 值变化触发器 onChange
     */
    valueTrigger?: string;
    /**
     * 数值名
     */
    valueName?: string;
    /**
     * 初始值
     */
    value?: any;
    /**
     * 字段key
     */
    name: string;
    /**
     * 是否为必填项
     */
    required?: boolean;
    /**
     * 错误提示信息
     */
    message?: string;
    /**
     * 校验器
     */
    checkers?: Array<(v: any) => boolean | string>;
    /**
     * 包裹的控件
     */
    children: React.ReactElement<any>;
    /**
     * 标题名
     */
    label: React.ReactNode;
    /**
     * label布局
     */
    labelCol?: IColProps;
    /**
     * 控件布局
     */
    wrapperCol?: IColProps;
    row?: IRowProps;
}
export interface IValidatorState {
    value: any;
    error: boolean;
    message: string;
}
/**
 * **组件中文名称**-组件描述。
 */
export declare class Validator extends Component<IValidatorProps, IValidatorState> {
    preCls: string;
    labelId: string;
    static contextTypes: {
        onChange: PropTypes.Requireable<(...args: any[]) => any>;
        onDelete: PropTypes.Requireable<(...args: any[]) => any>;
        onPushChecker: PropTypes.Requireable<(...args: any[]) => any>;
        onDeleteChecker: PropTypes.Requireable<(...args: any[]) => any>;
        row: PropTypes.Requireable<object>;
        wrapperCol: PropTypes.Requireable<object>;
        labelCol: PropTypes.Requireable<object>;
        rt: PropTypes.Requireable<boolean>;
        requiredMsg: PropTypes.Requireable<string>;
        defaultValue: PropTypes.Requireable<object>;
    };
    static defaultProps: {
        valueTrigger: string;
        valueName: string;
        value: string;
    };
    state: {
        value: any;
        error: boolean;
        message: string;
    };
    componentDidMount(): void;
    componentWillUnmount(): void;
    onChange: (v: any) => void;
    onCheck: () => boolean;
    renderChildren: () => React.ReactElement<any>;
    render(): JSX.Element;
}
export default Validator;
