import * as tslib_1 from "tslib";
// tslint:disable no-any
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
import Grid from '../Grid';
import Transitions from '../Transitions';
import * as PropTypes from 'prop-types';
var Row = Grid.Row, Col = Grid.Col;
var Slide = Transitions.Slide;
/**
 * **组件中文名称**-组件描述。
 */
var Validator = /** @class */ (function (_super) {
    tslib_1.__extends(Validator, _super);
    function Validator() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.preCls = 'yoshino-validator';
        _this.labelId = "validator-" + Math.round(new Date().getTime() * Math.random());
        _this.state = {
            value: _this.props.value,
            error: false,
            message: '',
        };
        _this.onChange = function (v) {
            var name = _this.props.name;
            _this.context.onChange(name, v);
            _this.setState({
                value: v,
            }, function () {
                if (_this.context.rt || _this.state.error) {
                    _this.onCheck();
                }
            });
        };
        _this.onCheck = function () {
            var _a = _this.props, checkers = _a.checkers, required = _a.required;
            var value = _this.state.value;
            var message = '';
            var flag = true; // 校验是否全部通过
            if (required && value === '') {
                flag = false;
            }
            else if (checkers) {
                flag = checkers.every(function (c) {
                    var r = c(value);
                    if (typeof r === 'string') {
                        message = r;
                    }
                    return r === true;
                });
            }
            _this.setState({
                error: !flag,
                message: message,
            });
            return flag;
        };
        _this.renderChildren = function () {
            var _a;
            var _b = _this.props, children = _b.children, valueName = _b.valueName, valueTrigger = _b.valueTrigger;
            var value = _this.state.value;
            var id = children.props.id;
            return React.cloneElement(children, (_a = {},
                _a["" + valueName] = value,
                _a["" + valueTrigger] = _this.onChange,
                _a.id = id ? id + " " + _this.labelId : _this.labelId,
                _a));
        };
        return _this;
    }
    Validator.prototype.componentDidMount = function () {
        var _this = this;
        var _a = this.props, name = _a.name, value = _a.value;
        var parentValue = this.context.defaultValue[name];
        if (parentValue !== undefined) {
            this.setState({ value: parentValue }, function () {
                _this.context.onChange(name, parentValue);
            });
        }
        else {
            this.context.onChange(name, value);
        }
        this.context.onPushChecker(name, this.onCheck);
    };
    Validator.prototype.componentWillUnmount = function () {
        var name = this.props.name;
        this.context.onDelete(name);
        this.context.onDeleteChecker(this.onCheck);
    };
    Validator.prototype.render = function () {
        var _a, _b;
        var _c = this.props, className = _c.className, style = _c.style, children = _c.children, valueName = _c.valueName, message = _c.message, valueTrigger = _c.valueTrigger, checkers = _c.checkers, label = _c.label, labelCol = _c.labelCol, wrapperCol = _c.wrapperCol, row = _c.row, required = _c.required, otherProps = tslib_1.__rest(_c, ["className", "style", "children", "valueName", "message", "valueTrigger", "checkers", "label", "labelCol", "wrapperCol", "row", "required"]);
        var error = this.state.error;
        var preCls = this.preCls;
        var rowR = row || this.context.row;
        var labelColR = labelCol || this.context.labelCol;
        var wrapperColR = wrapperCol || this.context.wrapperCol;
        var clsName = classNames(preCls, className, (_a = {},
            _a[preCls + "-has-error"] = error,
            _a));
        var labelCls = classNames(this.preCls + "-label", (_b = {},
            _b[this.preCls + "-required"] = required,
            _b));
        return (React.createElement("div", tslib_1.__assign({ className: clsName, style: style }, otherProps),
            React.createElement(Row, tslib_1.__assign({}, rowR),
                React.createElement(Col, tslib_1.__assign({ className: preCls + "-item-label" }, labelColR),
                    React.createElement("label", { htmlFor: this.labelId, className: labelCls },
                        label,
                        ":")),
                React.createElement(Col, tslib_1.__assign({}, wrapperColR),
                    React.createElement("div", { className: preCls + "-control" }, this.renderChildren()))),
            React.createElement(Slide, { direction: 'top', active: error },
                React.createElement("div", { className: preCls + "-error-container" },
                    React.createElement(Row, tslib_1.__assign({}, rowR),
                        React.createElement(Col, tslib_1.__assign({}, labelColR)),
                        React.createElement(Col, tslib_1.__assign({}, wrapperColR),
                            React.createElement("div", { className: preCls + "-error" }, error ? (this.state.message || message || this.context.requiredMsg.replace(/\$\{name\}/g, label)) : null)))))));
    };
    Validator.contextTypes = {
        onChange: PropTypes.func,
        onDelete: PropTypes.func,
        onPushChecker: PropTypes.func,
        onDeleteChecker: PropTypes.func,
        row: PropTypes.object,
        wrapperCol: PropTypes.object,
        labelCol: PropTypes.object,
        rt: PropTypes.bool,
        requiredMsg: PropTypes.string,
        defaultValue: PropTypes.object,
    };
    Validator.defaultProps = {
        valueTrigger: 'onChange',
        valueName: 'value',
        value: '',
    };
    return Validator;
}(Component));
export { Validator };
export default Validator;
//# sourceMappingURL=Validator.js.map