import { Component, ReactNode, CSSProperties } from 'react';
import * as React from 'react';
import { IAbstractInput } from '../template/component';
export interface IInputProps extends IAbstractInput<string> {
    /**
     * 组件大小
     */
    size?: 'small' | 'default' | 'large';
    /**
     * 回车回调事件
     */
    onEnter?: () => void;
    /**
     * 头部
     */
    header?: ReactNode | string;
    /**
     * 尾部
     */
    footer?: ReactNode | string;
    /**
     * 头部style
     */
    headerStyle?: CSSProperties;
    /**
     * 尾部style
     */
    footerStyle?: CSSProperties;
    /**
     * input实例
     */
    refInput?: (v: HTMLInputElement) => void;
    /**
     * 禁用
     */
    disabled?: boolean;
    /**
     * 紧凑模式
     */
    compact?: boolean;
}
export interface IInputState {
    /**
     * 值
     */
    value: string;
}
/**
 * **输入框**-用于获取用书通过键盘输入的内容
 */
export declare class Input extends Component<IInputProps, IInputState> {
    static defaultProps: {
        size: string;
        defaultValue: string;
        disabled: boolean;
        compact: boolean;
    };
    state: {
        value: string;
    };
    getValue: () => string;
    onChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
    onEnter: (e: React.KeyboardEvent<HTMLInputElement>) => void;
    render(): JSX.Element;
}
export default Input;
