import { Component } from 'react';
import { IBaseComponent, TKey } from '../template/component';
import MenuItem from './MenuItem';
import SubMenu from './SubMenu';
import MenuItemGroup from './MenuItemGroup';
export interface IMenuProps extends IBaseComponent {
    /**
     * 模式
     */
    mode?: 'vertical' | 'horizontal';
    /**
     * 受控 - 激活key
     */
    activeKey?: TKey;
    /**
     * 非受控 - 激活key
     */
    defaultActiveKey?: TKey;
    /**
     * 受控 - 展开key
     */
    openKeys?: TKey[];
    /**
     * 非受控 - 展开key
     */
    defaultOpenKeys?: TKey[];
    /**
     * item - 选中回调
     */
    onSelect?: (activeKey: TKey) => void;
    /**
     * 展开回调
     */
    onOpenChange?: (openKeys: TKey[]) => void;
    /**
     * 偏移量
     */
    offset?: number;
}
export interface IMenuState {
}
/**
 * **菜单**-提供导航功能
 */
export declare class Menu extends Component<IMenuProps, IMenuState> {
    static Item: typeof MenuItem;
    static SubMenu: typeof SubMenu;
    static ItemGroup: typeof MenuItemGroup;
    static defaultProps: {
        defaultActiveKey: string;
        defaultOpenKeys: never[];
        offset: number;
        mode: string;
    };
    getCtx: () => {
        mode: "horizontal" | "vertical" | undefined;
        activeKey: string | undefined;
        openKeys: string[];
        onSelect: (key: string) => void;
        onOpenChange: (openKey: string) => void;
        offset: number | undefined;
    };
    state: {
        activeKey: string | undefined;
        openKeys: string[];
    };
    getActiveKey: () => string | undefined;
    onSelect: (key: string) => void;
    onSelectTrigger: (activeKey: string) => void;
    getOpenKeys: () => string[];
    onOpenChange: (openKey: string) => void;
    onOpenChangeTrigger: (openKeys: string[]) => void;
    render(): JSX.Element;
}
export default Menu;
