import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
/**
 * **菜单**-提供导航功能
 */
var MenuItem = /** @class */ (function (_super) {
    tslib_1.__extends(MenuItem, _super);
    function MenuItem() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onSelect = function () {
            var _a = _this.props, keyId = _a.keyId, disabled = _a.disabled, onClick = _a.onClick, ctx = _a.ctx;
            var onSelect = ctx.onSelect;
            if (disabled) {
                return;
            }
            if (onSelect) {
                onSelect(keyId);
            }
            if (onClick) {
                onClick();
            }
        };
        return _this;
    }
    MenuItem.prototype.render = function () {
        var _a;
        var _b = this.props, className = _b.className, style = _b.style, children = _b.children, deep = _b.deep, keyId = _b.keyId, disabled = _b.disabled, ctx = _b.ctx;
        var activeKey = ctx.activeKey, offset = ctx.offset, mode = ctx.mode;
        var preCls = 'yoshino-menu-item';
        var clsName = classNames(preCls, className, (_a = {},
            _a[preCls + "-active"] = activeKey === keyId,
            _a[preCls + "-disabled"] = disabled,
            _a));
        var isVertical = mode === 'vertical';
        var paddingLeft = isVertical ? deep * offset + "px" : '';
        return (React.createElement("li", { className: clsName, style: tslib_1.__assign({ paddingLeft: paddingLeft }, style), onClick: this.onSelect, key: keyId }, children));
    };
    MenuItem.defaultProps = {
        disabled: false,
    };
    return MenuItem;
}(Component));
export { MenuItem };
export default MenuItem;
//# sourceMappingURL=MenuItem.js.map