import { ReactNode } from 'react';
export interface INotification {
    key?: string | number;
    duration?: number;
    icon?: ReactNode;
    title: ReactNode | string;
    message?: ReactNode | string;
    onClose?: () => void;
}
export interface INotificationConfig {
    vertical?: number;
    horizontal?: number;
    duration?: number;
    placement?: 'topLeft' | 'topRight' | 'bottomLeft' | 'bottomRight';
}
declare const _default: {
    config: (props: INotificationConfig) => void;
    open: (props: INotification) => string | number;
    success: (props: INotification) => string | number;
    info: (props: INotification) => string | number;
    warn: (props: INotification) => string | number;
    error: (props: INotification) => string | number;
    close: (key: string | number) => void;
    destroy: () => void;
};
export default _default;
