import * as tslib_1 from "tslib";
// tslint:disable no-any
import { Component } from 'react';
import * as React from 'react';
import { RenderInRootDom } from '../utils/';
import Helpers from '../Helpers';
import Transitions from '../Transitions';
var Scale = Transitions.Scale;
var ClickOutside = Helpers.ClickOutside;
/**
 * **组件中文名称**-组件描述。
 */
var PopOver = /** @class */ (function (_super) {
    tslib_1.__extends(PopOver, _super);
    function PopOver() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.preCls = 'yoshino-pop-over';
        _this.state = {
            popPos: {
                left: 0,
                top: 0,
            },
        };
        _this.setPopOverPosition = function () {
            if (!_this.refPopOverContainer) {
                return;
            }
            var rect = _this.refPopOverContainer.getBoundingClientRect();
            var pageY = window.pageYOffset; // 当前滚动条y轴偏移量
            var pageX = window.pageXOffset; // 当前滚动条x轴偏移量
            _this.setState({
                popPos: {
                    left: rect.left + pageX,
                    top: rect.top + pageY,
                }
            });
        };
        _this.onOpenChange = function (open) {
            var onOpenChange = _this.props.onOpenChange;
            if (onOpenChange) {
                onOpenChange(open);
            }
            // 调整面板位置
            _this.setPopOverPosition();
        };
        return _this;
    }
    PopOver.prototype.componentDidMount = function () {
        this.setPopOverPosition();
    };
    PopOver.prototype.render = function () {
        var _this = this;
        var _a = this.props, children = _a.children, pop = _a.pop, open = _a.open, onEntered = _a.onEntered, unmountOnExit = _a.unmountOnExit;
        var preCls = this.preCls;
        var child = React.Children.only(children);
        return (React.createElement(React.Fragment, null,
            React.cloneElement(child, {
                onClick: function () {
                    if (child.props.onClick) {
                        child.props.onClick();
                    }
                    _this.onOpenChange(true);
                },
                ref: function (v) {
                    if (child.props.ref) {
                        child.props.ref(v);
                    }
                    if (v) {
                        _this.refPopOverContainer = v;
                    }
                }
            }),
            React.createElement(RenderInRootDom, null,
                React.createElement(ClickOutside, { clickOutside: function () {
                        _this.onOpenChange(false);
                    } },
                    React.createElement("div", { className: preCls + "-box", style: this.state.popPos },
                        React.createElement(Scale, { timeout: 300, active: open, unmountOnExit: unmountOnExit, onEntered: function () {
                                if (onEntered) {
                                    onEntered();
                                }
                            } }, pop))))));
    };
    PopOver.defaultProps = {
        unmountOnExit: true,
    };
    return PopOver;
}(Component));
export { PopOver };
export default PopOver;
//# sourceMappingURL=PopOver.js.map