import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
import rippleJs from './rippleJs';
/**
 * **波纹特效**-为子代添加点击水波扩散的特效。
 */
var Ripple = /** @class */ (function (_super) {
    tslib_1.__extends(Ripple, _super);
    function Ripple() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Ripple.prototype.componentDidMount = function () {
        var _a = this.props, color = _a.color, opacity = _a.opacity;
        if (this.targetRipple !== null) {
            this.rippleHandle = rippleJs({ dom: this.targetRipple, color: color, opacity: opacity });
        }
    };
    Ripple.prototype.componentWillUnmount = function () {
        // ripple事件销毁
        this.rippleHandle();
    };
    Ripple.prototype.render = function () {
        var _this = this;
        var _a = this.props, className = _a.className, style = _a.style, children = _a.children, otherProps = tslib_1.__rest(_a, ["className", "style", "children"]);
        var preCls = 'yoshino-ripple';
        var clsName = classNames(preCls, className);
        return (React.createElement("div", tslib_1.__assign({ className: clsName, style: style }, otherProps, { ref: function (dom) { return _this.targetRipple = dom; } }), this.props.children));
    };
    Ripple.defaultProps = {
        opacity: 0.3,
        diameter: 10,
    };
    return Ripple;
}(Component));
export { Ripple };
export default Ripple;
//# sourceMappingURL=Ripple.js.map