import { Component, ReactNode } from 'react';
import { IBaseComponent } from '../template/component';
import { BasicValue, Value } from './Select';
export interface IOptionProps extends IBaseComponent {
    /**
     * 是否禁用
     */
    disabled?: boolean;
    /**
     * value
     */
    value: BasicValue;
    children: ReactNode;
    /**
     * 激活项，由外层Select传递，开发者不需要传，否则会影响组件正常使用
     */
    active?: BasicValue;
    /**
     * 用于通知父组件 - 子代值发生变化
     */
    onChange?: (value: BasicValue) => void;
    /**
     * context
     */
    ctx?: IContext;
}
export interface IContext {
    onChange: (value: BasicValue) => void;
    value: Value;
}
export interface IOptionState {
}
/**
 * **组件中文名称**-组件描述。
 */
export declare class Option extends Component<IOptionProps, IOptionState> {
    static defaultProps: {};
    static displayName: string;
    onChange: (value: BasicValue) => void;
    render(): JSX.Element;
}
export default Option;
