import { Component } from 'react';
import { IBaseComponent } from '../template/component';
import Option from './Option';
import OptGroup from './OptGroup';
export declare type BasicValue = string | number | boolean;
export declare type Value = BasicValue | BasicValue[];
export interface ISelectProps extends IBaseComponent {
    /**
     * 受控值
     */
    value?: Value;
    /**
     * 默认值
     */
    defaultValue?: Value;
    /**
     * 是否禁用
     */
    disabled?: boolean;
    /**
     * 变化回调
     */
    onChange?: (value: Value) => void;
    /**
     * 尺寸
     */
    size?: 'small' | 'large' | 'default';
    /**
     * 模式
     */
    mode?: 'single' | 'multiple';
    /**
     * placeholder
     */
    placeholder?: string;
}
export interface ISelectState {
    value: Value;
    visible: boolean;
}
/**
 * **组件中文名称**-组件描述。
 */
export declare class Select extends Component<ISelectProps, ISelectState> {
    toggleTimeOutHandle: number;
    mapArr: Array<{
        value: string | number;
        text: any;
    }>;
    static defaultProps: {
        mode: string;
        size: string;
        defaultValue: string;
    };
    constructor(props: ISelectProps);
    timeout: number;
    static Option: typeof Option;
    static OptGroup: typeof OptGroup;
    state: {
        value: Value;
        visible: boolean;
    };
    getValue: () => Value;
    onChange: (value: BasicValue) => void;
    onChangeTrigger: (value: BasicValue) => void;
    toggleVisible: (visible: boolean) => void;
    value2Text: (v?: string | number | boolean | undefined) => any;
    render(): JSX.Element;
}
export default Select;
