import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
/**
 * **组件中文名称**-组件描述。
 */
var Skeleton = /** @class */ (function (_super) {
    tslib_1.__extends(Skeleton, _super);
    function Skeleton() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.preCls = 'yoshino-skeleton';
        _this.createLi = function (rows, width) {
            var temp = [];
            for (var i = 1; i <= rows; i++) {
                if (i === rows && width !== undefined) {
                    temp.push(React.createElement("li", { style: { width: width } }));
                }
                else {
                    temp.push(React.createElement("li", { key: i }));
                }
            }
            return temp;
        };
        return _this;
    }
    Skeleton.prototype.render = function () {
        var _a;
        var _b = this.props, className = _b.className, style = _b.style, active = _b.active, loading = _b.loading, rows = _b.rows, lastWidth = _b.lastWidth, children = _b.children, otherProps = tslib_1.__rest(_b, ["className", "style", "active", "loading", "rows", "lastWidth", "children"]);
        var preCls = this.preCls;
        var clsName = classNames(preCls, className, (_a = {}, _a[preCls + "-animate"] = active, _a));
        return (React.createElement("div", tslib_1.__assign({ className: clsName, style: style }, otherProps), loading ? (React.createElement("ul", { className: preCls + "-paragraph" }, typeof rows === 'number' ? (React.createElement(React.Fragment, null, this.createLi(rows, lastWidth))) : (rows.map(function (item, index) {
            return (React.createElement("li", { key: index, style: item }));
        })))) : children));
    };
    Skeleton.defaultProps = {
        rows: 3,
        lastWidth: '80%',
        loading: true,
    };
    return Skeleton;
}(Component));
export { Skeleton };
export default Skeleton;
//# sourceMappingURL=Skeleton.js.map