import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
/**
 * **开关选择器**-切换开关状态。
 */
var Switch = /** @class */ (function (_super) {
    tslib_1.__extends(Switch, _super);
    function Switch() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            checked: _this.props.defaultChecked,
        };
        _this.onClick = function () {
            if (_this.props.disabled) {
                return;
            }
            var checked = !_this.getChecked();
            _this.setState({
                checked: checked,
            });
            if (_this.props.onChange) {
                _this.props.onChange(checked);
            }
        };
        _this.getChecked = function () {
            var checked = _this.props.checked;
            return checked !== undefined ? checked : _this.state.checked;
        };
        return _this;
    }
    Switch.prototype.render = function () {
        var _a;
        var _b = this.props, className = _b.className, style = _b.style, size = _b.size, disabled = _b.disabled;
        var checked = this.getChecked();
        var preCls = 'yoshino-switch';
        var switchCls = (_a = {},
            _a[preCls + "-checked"] = checked,
            _a[preCls + "-disabled"] = disabled,
            _a);
        var clsName = classNames(preCls, preCls + "-" + size, switchCls, className);
        return (React.createElement("div", { className: clsName, style: style, onClick: this.onClick }));
    };
    Switch.defaultProps = {
        size: 'default',
        disabled: false,
        defaultChecked: false,
    };
    return Switch;
}(Component));
export { Switch };
export default Switch;
//# sourceMappingURL=Switch.js.map