import { Component } from 'react';
import { IBaseComponent, TKey, TSize } from '../template/component';
import Pane from './Pane';
export interface ITabsProps extends IBaseComponent {
    /**
     * 当前激活 tab 面板的 key， 对应name
     */
    activeKey?: TKey;
    /**
     * 当前激活 tab 面板的 key， 对应name
     */
    defaultActivetKey?: TKey;
    /**
     * 面板切换回调
     */
    onChange?: (activeKey: TKey) => void;
    /**
     * 标签页样式
     */
    type?: 'line' | 'card';
    /**
     * 是否启用动画
     */
    animated?: boolean;
    /**
     * 大小
     */
    size?: TSize;
    /**
     * TabPane间隙
     */
    tabBarGutter?: number;
    /**
     * 点击tab
     */
    onTabClick?: (name: TKey) => void;
    /**
     * tab位置
     */
    tabPosition?: 'left' | 'right' | 'top' | 'bottom';
}
export interface ITabsState {
    activeKey: TKey;
    activeIndex: number;
    ink: {
        height: number;
        width: number;
        left: number;
        top: number;
    };
}
/**
 * **组件中文名称**-组件描述。
 */
export declare class Tabs extends Component<ITabsProps, ITabsState> {
    preCls: string;
    refActiveTabPaneArr: HTMLElement[];
    static defaultProps: {
        size: string;
        tabPosition: string;
        animated: boolean;
        type: string;
    };
    static TabPane: typeof Pane;
    state: {
        activeIndex: number;
        activeKey: string;
        ink: {
            height: number;
            width: number;
            left: number;
            top: number;
        };
    };
    componentDidMount(): void;
    componentDidUpdate(preProps: ITabsProps): void;
    resetInkBarStyle: (e: HTMLElement) => void;
    getActiveKey: () => string;
    onChange: (key: string) => void;
    renderTabPane: () => JSX.Element;
    renderTabPaneContent: () => JSX.Element;
    render(): JSX.Element;
}
export default Tabs;
