import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
import Icon from '../Icon';
import Transitions from '../Transitions';
import { getRGB } from '../utils/colorFormat';
var Scale = Transitions.Scale;
/**
 * **标签**-一般用于描述或者分类
 */
var Tag = /** @class */ (function (_super) {
    tslib_1.__extends(Tag, _super);
    function Tag() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            show: true,
        };
        _this.closeTag = function (e) {
            e.stopPropagation();
            var onClose = _this.props.onClose;
            if (onClose) {
                onClose();
            }
            _this.setState({
                show: false,
            });
        };
        _this.getGeekStyle = function () {
            var geekStyle = {};
            if (_this.props.color) {
                var rgb = tslib_1.__assign({}, getRGB(_this.props.color));
                var r = rgb.r;
                var g = rgb.g;
                var b = rgb.b;
                geekStyle = {
                    color: "rgb(" + r + ", " + g + ", " + b + ")",
                    background: "rgba(" + r + ", " + g + ", " + b + ", 0.3)",
                    borderColor: "rgba(" + r + ", " + g + ", " + b + ", 0.5)",
                };
            }
            return geekStyle;
        };
        return _this;
    }
    Tag.prototype.render = function () {
        var _a;
        var _b = this.props, className = _b.className, style = _b.style, children = _b.children, closeable = _b.closeable, color = _b.color, onClose = _b.onClose, _c = _b.mode, mode = _c === void 0 ? 'custom' : _c, otherProps = tslib_1.__rest(_b, ["className", "style", "children", "closeable", "color", "onClose", "mode"]);
        var show = this.state.show;
        var preCls = 'yoshino-tag';
        var clsName = classNames(preCls, (_a = {}, _a[preCls + "-color"] = !!color && mode !== 'geek', _a), className);
        var modeStyle = {
            custom: {
                backgroundColor: color,
            },
            geek: this.getGeekStyle(),
        };
        var tagStyle = color ? modeStyle[mode] : {};
        return (React.createElement(Scale, { active: show, timeout: 300 },
            React.createElement("span", tslib_1.__assign({ className: clsName, style: tslib_1.__assign({}, tagStyle, style) }, otherProps),
                React.createElement("div", { className: preCls + "-container" },
                    React.createElement("span", null, children),
                    closeable ? (React.createElement(Icon, { type: 'ios-close', className: preCls + "-close", onClick: this.closeTag })) : null))));
    };
    Tag.defaultProps = {
        mode: 'custom',
    };
    return Tag;
}(Component));
export { Tag };
export default Tag;
//# sourceMappingURL=Tag.js.map