import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
/**
 * **时间轴**-用于展示不同时间节点上的信息。
 */
var Timeline = /** @class */ (function (_super) {
    tslib_1.__extends(Timeline, _super);
    function Timeline() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Timeline.prototype.render = function () {
        var _a = this.props, className = _a.className, style = _a.style, children = _a.children, iconColor = _a.iconColor, iconLine = _a.iconLine, iconType = _a.iconType, lineColor = _a.lineColor, lineType = _a.lineType, iconWidth = _a.iconWidth, lineWidth = _a.lineWidth, otherProps = tslib_1.__rest(_a, ["className", "style", "children", "iconColor", "iconLine", "iconType", "lineColor", "lineType", "iconWidth", "lineWidth"]);
        var preCls = 'yoshino-timeline';
        var childrens = React.Children.toArray(children).filter(function (item) { return item; });
        var clsName = classNames(preCls, className);
        return (React.createElement("div", tslib_1.__assign({ className: clsName, style: style }, otherProps), React.Children.map(childrens, function (ele) {
            return React.cloneElement(ele, {
                parentIcon: {
                    width: iconWidth,
                    color: iconColor,
                    line: iconLine,
                    type: iconType,
                },
                parentLine: {
                    color: lineColor,
                    width: lineWidth,
                    type: lineType,
                },
            });
        })));
    };
    Timeline.defaultProps = {
        iconColor: '',
        iconLine: 2,
        iconType: 'solid',
        lineColor: '',
        lineType: 'solid',
        iconWidth: 15,
        lineWidth: 2,
    };
    return Timeline;
}(Component));
export { Timeline };
export default Timeline;
//# sourceMappingURL=Timeline.js.map