import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import Transition from 'react-transition-group/Transition';
/**
 * **组件中文名称**-组件描述。
 */
var Expand = /** @class */ (function (_super) {
    tslib_1.__extends(Expand, _super);
    function Expand() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Expand.prototype.render = function () {
        var _this = this;
        var _a = this.props, active = _a.active, timeout = _a.timeout, children = _a.children, unmountOnExit = _a.unmountOnExit, mountOnEnter = _a.mountOnEnter, onEntered = _a.onEntered;
        var preCls = 'yoshino-expand';
        return (React.createElement(Transition, { timeout: timeout, in: active, mountOnEnter: mountOnEnter, unmountOnExit: unmountOnExit, appear: true, onEnter: function () {
                _this.refContainer.style.overflow = 'hidden';
                _this.refContainer.style.height = '0px';
                _this.refContainer.style.display = 'none';
            }, onEntering: function () {
                _this.refContainer.style.display = 'block';
                var height = _this.refInner.clientHeight;
                _this.refContainer.style.height = height + 1 + "px";
            }, onEntered: function () {
                _this.refContainer.style.overflow = null;
                _this.refContainer.style.height = null;
                if (onEntered) {
                    onEntered();
                }
            }, onExit: function () {
                _this.refContainer.style.overflow = 'hidden';
                var height = _this.refInner.clientHeight;
                _this.refContainer.style.height = height + 1 + "px";
            }, onExiting: function () {
                // 可能是react-transition的一个bug，直接执行会导致onExit中的高度设置无效
                setTimeout(function () {
                    _this.refContainer.style.height = '0px';
                }, 0);
            }, onExited: function () {
                _this.refContainer.style.height = null;
                _this.refContainer.style.display = 'none';
                _this.refContainer.style.overflow = null;
            } }, function () {
            var transition = "height " + timeout / 1000 + "s cubic-bezier(0.645, 0.045, 0.355, 1)";
            return (React.createElement("div", { className: preCls, style: {
                    transition: transition,
                    WebkitTransition: transition,
                }, ref: function (v) {
                    if (v) {
                        _this.refContainer = v;
                    }
                } },
                React.createElement("div", { ref: function (v) {
                        if (v) {
                            _this.refInner = v;
                        }
                    } }, children)));
        }));
    };
    Expand.defaultProps = {
        timeout: 300,
        mountOnEnter: true,
        unmountOnExit: true,
    };
    return Expand;
}(Component));
export { Expand };
export default Expand;
//# sourceMappingURL=Expand.js.map