import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import { Transition } from 'react-transition-group';
/**
 * **组件中文名称**-组件描述。
 */
var Scale = /** @class */ (function (_super) {
    tslib_1.__extends(Scale, _super);
    function Scale() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Scale.prototype.render = function () {
        var _this = this;
        var _a = this.props, active = _a.active, timeout = _a.timeout, children = _a.children, mountOnEnter = _a.mountOnEnter, unmountOnExit = _a.unmountOnExit, onEntered = _a.onEntered;
        var transition = {
            exit: 'scale(0)',
            enter: 'scale(1)',
        };
        return (React.createElement(Transition, { timeout: timeout, in: active, mountOnEnter: mountOnEnter, unmountOnExit: unmountOnExit, appear: true, onEnter: function () {
                _this.refChild.style.transform = transition.exit;
                _this.refChild.style.opacity = '0';
                _this.refChild.style.display = null;
            }, onEntering: function () {
                setTimeout(function () {
                    _this.refChild.style.transform = transition.enter;
                    _this.refChild.style.opacity = '1';
                }, 0);
            }, onEntered: function () {
                _this.refChild.style.transform = null;
                _this.refChild.style.opacity = null;
                if (onEntered) {
                    onEntered();
                }
            }, onExit: function () {
                _this.refChild.style.transform = transition.enter;
                _this.refChild.style.opacity = '1';
            }, onExiting: function () {
                setTimeout(function () {
                    _this.refChild.style.transform = transition.exit;
                    _this.refChild.style.opacity = '0';
                }, 0);
            }, onExited: function () {
                _this.refChild.style.transform = null;
                _this.refChild.style.opacity = null;
                _this.refChild.style.display = 'none';
            } }, function () {
            var child = React.Children.only(children);
            var transition = "all " + timeout / 1000 + "s cubic-bezier(.645,.045,.355,1)";
            return React.cloneElement(child, {
                style: tslib_1.__assign({}, child.props.style, { transition: transition, WebkitTransition: transition }),
                ref: function (v) {
                    if (v) {
                        _this.refChild = v;
                    }
                    if (child.props.ref) {
                        child.props.ref();
                    }
                }
            });
        }));
    };
    Scale.defaultProps = {
        timeout: 300,
        mountOnEnter: true,
        unmountOnExit: true,
    };
    return Scale;
}(Component));
export { Scale };
export default Scale;
//# sourceMappingURL=Scale.js.map