import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import { Transition } from 'react-transition-group';
/**
 * **组件中文名称**-组件描述。
 */
var Slide = /** @class */ (function (_super) {
    tslib_1.__extends(Slide, _super);
    function Slide() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Slide.prototype.render = function () {
        var _this = this;
        var _a = this.props, active = _a.active, timeout = _a.timeout, children = _a.children, direction = _a.direction, single = _a.single, opacity = _a.opacity, appear = _a.appear, unmountOnExit = _a.unmountOnExit, mountOnEnter = _a.mountOnEnter, onEntered = _a.onEntered;
        var transition = {
            left: {
                enter: 'translateX(0)',
                exit: 'translateX(-100%)',
            },
            right: {
                enter: 'translateX(0)',
                exit: 'translateX(100%)',
            },
            top: {
                enter: 'translateY(0)',
                exit: 'translateY(-100%)',
            },
            bottom: {
                enter: 'translateY(0)',
                exit: 'translateY(100%)',
            },
        };
        var singleDiretion = {
            left: 'right',
            right: 'left',
            top: 'bottom',
            bottom: 'top',
        };
        return (React.createElement(Transition, { timeout: timeout, in: active, mountOnEnter: mountOnEnter, unmountOnExit: unmountOnExit, appear: appear, onEnter: function () {
                _this.refChild.style.transform = transition[direction].exit;
                if (opacity) {
                    _this.refChild.style.opacity = '0';
                }
                _this.refChild.style.display = null;
            }, onEntering: function () {
                setTimeout(function () {
                    _this.refChild.style.transform = transition[direction].enter;
                    if (opacity) {
                        _this.refChild.style.opacity = '1';
                    }
                }, 0);
            }, onEntered: function () {
                _this.refChild.style.transform = null;
                if (opacity) {
                    _this.refChild.style.opacity = null;
                }
                if (onEntered) {
                    onEntered();
                }
            }, onExit: function () {
                var directionR = single ? singleDiretion[direction] : direction;
                _this.refChild.style.transform = transition[directionR].enter;
                if (opacity) {
                    _this.refChild.style.opacity = '1';
                }
            }, onExiting: function () {
                setTimeout(function () {
                    var directionR = single ? singleDiretion[direction] : direction;
                    _this.refChild.style.transform = transition[directionR].exit;
                    if (opacity) {
                        _this.refChild.style.opacity = '0';
                    }
                }, 0);
            }, onExited: function () {
                _this.refChild.style.transform = null;
                if (opacity) {
                    _this.refChild.style.opacity = null;
                }
                _this.refChild.style.display = 'none';
            } }, function () {
            var child = React.Children.only(children);
            var transition = "all " + timeout / 1000 + "s cubic-bezier(.645,.045,.355,1)";
            return React.cloneElement(child, {
                style: tslib_1.__assign({}, child.props.style, { transition: transition, WebkitTransition: transition }),
                ref: function (v) {
                    if (v) {
                        _this.refChild = v;
                    }
                    if (child.props.ref) {
                        child.props.ref();
                    }
                }
            });
        }));
    };
    Slide.defaultProps = {
        timeout: 300,
        single: false,
        opacity: true,
        appear: true,
        mountOnEnter: true,
        unmountOnExit: true,
    };
    return Slide;
}(Component));
export { Slide };
export default Slide;
//# sourceMappingURL=Slide.js.map