import * as tslib_1 from "tslib";
// tslint:disable no-any
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
import Transitions from '../Transitions';
import Icon from '../Icon';
var Expand = Transitions.Expand;
/**
 * **警告提示**-警告提示，展现需要关注的信息。
 */
var Alert = /** @class */ (function (_super) {
    tslib_1.__extends(Alert, _super);
    function Alert() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.duration = 200;
        _this.state = {
            show: true,
        };
        _this.closeAlert = function () {
            _this.setState({
                show: false,
            });
            setTimeout(function () {
                var onClose = _this.props.onClose;
                if (onClose) {
                    onClose();
                }
            }, _this.duration);
        };
        return _this;
    }
    Alert.prototype.render = function () {
        var _a, _b;
        var _c = this.props, className = _c.className, style = _c.style, showIcon = _c.showIcon, type = _c.type, closable = _c.closable, Animation = _c.Animation, animationProps = _c.animationProps, icon = _c.icon, title = _c.title, otherProps = tslib_1.__rest(_c, ["className", "style", "showIcon", "type", "closable", "Animation", "animationProps", "icon", "title"]);
        var show = this.state.show;
        var preCls = 'yoshino-alert';
        var defaultIcon = {
            success: 'md-checkmark-circle',
            info: 'md-information-circle',
            warning: 'md-alert',
            error: 'md-close-circle',
            normal: '',
        };
        var alertCls = (_a = {},
            _a[preCls + "-" + type] = true,
            _a[preCls + "-no-icon"] = !showIcon,
            _a[preCls + "-with-description"] = !!this.props.children,
            _a);
        var clsName = classNames(preCls, alertCls, className);
        var desClsName = classNames(preCls + "-title", (_b = {}, _b[preCls + "-has-icon-description"] = showIcon && !!this.props.children, _b));
        var content = (React.createElement("div", tslib_1.__assign({ className: clsName, style: tslib_1.__assign({}, style) }, otherProps),
            showIcon && (icon || type !== 'normal') ? (React.createElement("span", { className: preCls + "-icon" }, icon ? icon : (React.createElement(Icon, { type: defaultIcon[type] })))) : null,
            React.createElement("div", { className: desClsName },
                React.createElement("p", { className: preCls + "-message" }, title),
                this.props.children ? (React.createElement("p", { className: preCls + "-description" }, this.props.children)) : null),
            closable ? (React.createElement("span", { className: preCls + "-close", onClick: this.closeAlert },
                React.createElement(Icon, { type: 'md-close' }))) : null));
        return !Animation ? (React.createElement(Expand, { timeout: this.duration, active: show }, content)) : (React.createElement(Animation, tslib_1.__assign({}, animationProps, { timeout: this.duration, active: show }), content));
    };
    Alert.duration = 200;
    Alert.defaultProps = {
        showIcon: false,
        closable: false,
    };
    return Alert;
}(Component));
export { Alert };
export default Alert;
//# sourceMappingURL=Alert.js.map