import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
import Icon from '../Icon';
import { RenderInRootDom } from '../utils/';
import { backTop } from './assist';
/**
 * **返回顶部**-返回页面顶部的操作按钮。
 */
var BackTop = /** @class */ (function (_super) {
    tslib_1.__extends(BackTop, _super);
    function BackTop() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            show: false,
        };
        _this.scrollListener = function () {
            var height = _this.props.height ? _this.props.height : 200;
            var top = document.documentElement.scrollTop || document.body.scrollTop;
            var show = top >= height;
            _this.setState({
                show: show,
            });
        };
        return _this;
    }
    BackTop.prototype.componentDidMount = function () {
        window.addEventListener('scroll', this.scrollListener, false);
        window.addEventListener('resize', this.scrollListener, false);
    };
    BackTop.prototype.componentWillUnMount = function () {
        window.removeEventListener('scroll', this.scrollListener, false);
        window.removeEventListener('resize', this.scrollListener, false);
    };
    BackTop.prototype.render = function () {
        var _a = this.props, className = _a.className, style = _a.style, children = _a.children, bottom = _a.bottom, right = _a.right, duration = _a.duration, onBackTop = _a.onBackTop, otherProps = tslib_1.__rest(_a, ["className", "style", "children", "bottom", "right", "duration", "onBackTop"]);
        var preCls = 'yoshino-backtop';
        var clsName = classNames(preCls, className);
        var backtopStyle = {
            right: right + "px",
            bottom: bottom + "px",
        };
        return (React.createElement(RenderInRootDom, { boxClass: 'backtop' },
            React.createElement("div", tslib_1.__assign({ className: clsName, style: tslib_1.__assign({}, style, backtopStyle) }, otherProps, { onClick: backTop.bind(this, duration, onBackTop) }), this.state.show ? children ? children : (React.createElement("div", { className: preCls + "-default" },
                React.createElement(Icon, { type: 'ios-arrow-up' }))) : null)));
    };
    BackTop.defaultProps = {
        height: 200,
        bottom: 50,
        right: 50,
        duration: 500,
    };
    return BackTop;
}(Component));
export default BackTop;
//# sourceMappingURL=Backtop.js.map