import { Component, ReactNode } from 'react';
import { IBaseComponent } from '../template/component';
export interface ICarouselProps extends IBaseComponent {
    /**
     * 自动滚动
     */
    autoplay?: boolean;
    /**
     * 切换时间间隔
     */
    interval?: number;
    /**
     * 是否显示指示点
     */
    shwoDots?: boolean;
    /**
     * 垂直展示
     */
    vertical?: boolean;
    /**
     * 是否显示轮播控制器
     */
    showControl?: boolean;
    /**
     * 往前翻icon
     */
    preIcon?: ReactNode;
    /**
     * 往下翻icon
     */
    nextIcon?: ReactNode;
}
export interface ICarouselState {
    activeIndex: number;
    containerWidth: number;
    containerHeight: number;
}
/**
 * **组件中文名称**-组件描述。
 */
export declare class Carousel extends Component<ICarouselProps, ICarouselState> {
    preCls: string;
    intervalHandle: number;
    timeoutHandle: number;
    refContainer: HTMLElement;
    refList?: HTMLElement;
    jumpSwitch: boolean;
    componentDidMount(): void;
    componentWillMount(): void;
    setContainerBound: () => void;
    static defaultProps: {
        autoplay: boolean;
        interval: number;
        vertical: boolean;
        shwoDots: boolean;
        showControl: boolean;
    };
    state: {
        activeIndex: number;
        containerWidth: number;
        containerHeight: number;
    };
    setAutoplayInterval: () => void;
    getIndex: (step: number) => number;
    goto: (index: number) => void;
    next: () => void;
    pre: () => void;
    renderChild: () => JSX.Element;
    renderControl: () => JSX.Element;
    renderDots: () => JSX.Element;
    render(): JSX.Element;
}
export default Carousel;
