import { Component } from 'react';
import { IBaseComponent, TKey } from '../template/component';
import Panel from './Panel';
export interface ICollapseProps extends IBaseComponent {
    /**
     * 受控 - 激活key
     */
    activeKeys?: TKey[];
    /**
     * 非受控 - 激活key
     */
    defaultActiveKeys?: string[];
    /**
     * 手风琴模式
     */
    accordion?: boolean;
    /**
     * 变化回调
     */
    onChange?: (activeKeys: TKey[]) => void;
}
export interface ICollapseState {
}
/**
 * **折叠板**-可以放缩需要展示的内容区域。
 */
export declare class Collapse extends Component<ICollapseProps, ICollapseState> {
    static Panel: typeof Panel;
    static defaultProps: {
        defaultActiveKeys: never[];
        accordion: boolean;
    };
    state: {
        activeKeys: string[];
    };
    getActiveKey: () => string[];
    onChange: (key: string) => void;
    onChangeTrigger: (activeKeys: string[]) => void;
    render(): JSX.Element;
}
export default Collapse;
