import { Component, ReactNode } from 'react';
import { IBaseComponent, TKey } from '../template/component';
export interface IPanelProps extends IBaseComponent {
    /**
     * 标记，对应activekey
     */
    keyId?: TKey;
    /**
     * 折叠板标题
     */
    title: string | ReactNode;
    /**
     * 禁用
     */
    disabled?: boolean;
    /**
     * 激活
     */
    active?: boolean;
    /**
     * 变化回调
     */
    onChange?: (keyId: TKey) => void;
}
export interface IPanelState {
}
/**
 * **面板**-折叠版的子项
 */
export declare class Panel extends Component<IPanelProps, IPanelState> {
    static defaultProps: {
        disabled: boolean;
    };
    onChange: () => void;
    render(): JSX.Element;
}
export default Panel;
