import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
import Icon from '../Icon';
import Transitions from '../Transitions';
var Expand = Transitions.Expand;
/**
 * **面板**-折叠版的子项
 */
var Panel = /** @class */ (function (_super) {
    tslib_1.__extends(Panel, _super);
    function Panel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onChange = function () {
            var _a = _this.props, onChange = _a.onChange, disabled = _a.disabled, keyId = _a.keyId;
            if (disabled) {
                return;
            }
            if (onChange) {
                onChange(keyId);
            }
        };
        return _this;
    }
    Panel.prototype.render = function () {
        var _a;
        var _b = this.props, className = _b.className, style = _b.style, onChange = _b.onChange, title = _b.title, active = _b.active, children = _b.children, disabled = _b.disabled, keyId = _b.keyId, otherProps = tslib_1.__rest(_b, ["className", "style", "onChange", "title", "active", "children", "disabled", "keyId"]);
        var preCls = 'yoshino-panel';
        var clsName = classNames(preCls, (_a = {},
            _a[preCls + "-active"] = active,
            _a[preCls + "-disabled"] = disabled,
            _a), className);
        return (React.createElement("div", tslib_1.__assign({ className: clsName, style: style }, otherProps),
            React.createElement("div", { className: preCls + "-title", onClick: this.onChange },
                React.createElement(Icon, { type: 'ios-arrow-forward', className: preCls + "-icon" }),
                title),
            React.createElement(Expand, { timeout: 300, active: active },
                React.createElement("div", { className: preCls + "-content" },
                    React.createElement("div", { className: preCls + "-inner" }, children)))));
    };
    Panel.defaultProps = {
        disabled: false,
    };
    return Panel;
}(Component));
export { Panel };
export default Panel;
//# sourceMappingURL=Panel.js.map