import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
import Input from '../Input';
import Icon from '../Icon';
import PopOver from '../PopOver';
import TimePanel from '../TimePicker/TimePanel';
import Button from '../Button';
import * as moment from 'moment';
/**
 * **组件中文名称**-组件描述。
 */
var DatePicker = /** @class */ (function (_super) {
    tslib_1.__extends(DatePicker, _super);
    function DatePicker() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.preCls = 'yoshino-datepicker';
        _this.state = {
            open: _this.props.defaultOpen,
            value: _this.props.defaultValue,
            showTimePicker: false,
        };
        _this.getOpen = function () {
            var open = _this.props.open;
            return open !== undefined ? open : _this.state.open;
        };
        _this.getValue = function () {
            var value = _this.props.value;
            return value !== undefined ? value : _this.state.value;
        };
        _this.onOpenChange = function (open) {
            var _a = _this.props, onOpenChange = _a.onOpenChange, disabled = _a.disabled;
            if (!open) {
                _this.setState({ showTimePicker: false });
            }
            if (disabled) {
                return;
            }
            if (onOpenChange) {
                onOpenChange(open);
            }
            _this.setState({
                open: open,
            });
        };
        _this.onChange = function (value) {
            var onChange = _this.props.onChange;
            if (onChange) {
                onChange(value);
            }
            _this.setState({
                value: value,
            });
        };
        _this.renderPop = function () {
            var valueR = _this.getValue();
            var preCls = _this.preCls;
            var _a = _this.props, format = _a.format, placeholder = _a.placeholder, showTime = _a.showTime;
            var m = valueR ? moment(valueR) : moment();
            var weekArr = '日一二三四五六'.split('');
            var dayArr = []; // 7 * 6 = 42;
            var currentMonthMax = moment([m.year(), m.month()]).endOf('month').date();
            var currentMonthWeek = moment([m.year(), m.month(), 1]).weekday();
            var preMonthMax = moment([m.year(), m.month()]).subtract(1, 'month').endOf('month').date();
            // 填充跟上个月的末尾天
            if (currentMonthWeek !== 7) {
                for (var i = 0; i < currentMonthWeek; i++) {
                    var date = preMonthMax - i;
                    dayArr.push({
                        v: date,
                        tag: '-1',
                        moment: moment([m.year(), m.month(), date]).subtract(1, 'month').format(format),
                    });
                }
            }
            // 本月天数填充
            for (var i = 0; i < currentMonthMax; i++) {
                var date = 1 + i;
                dayArr.push({
                    v: 1 + i,
                    tag: '0',
                    moment: moment([m.year(), m.month(), date]).format(format),
                });
            }
            // 填充下个月开始天数
            for (var i = 0; dayArr.length < 42; i++) {
                var date = 1 + i;
                dayArr.push({
                    v: 1 + i,
                    tag: '1',
                    moment: moment([m.year(), m.month(), date]).add(1, 'month').format(format),
                });
            }
            var renderDate = function () {
                var trKey = 0;
                var count = 0;
                var arr = [];
                var temp = [];
                var _loop_1 = function (day) {
                    var _a;
                    var isCurrent = m.format(format) === day.moment;
                    var cls = classNames(preCls + "-table-cell", (_a = {},
                        _a[preCls + "-not-current-month"] = day.tag !== '0',
                        _a[preCls + "-selected-day"] = isCurrent,
                        _a));
                    temp.push(React.createElement("td", { key: count++, onClick: function () {
                            var newM = moment([m.year(), m.month(), m.date()]);
                            var tagAction = {
                                '-1': function () {
                                    newM = newM.subtract(1, 'month');
                                },
                                '0': function () { return -1; },
                                '1': function () {
                                    newM = newM.add(1, 'month');
                                },
                            };
                            tagAction[day.tag]();
                            _this.onChange(+newM.date(day.v).format('x'));
                            if (!showTime) {
                                _this.onOpenChange(false);
                            }
                        } },
                        React.createElement("div", { className: cls }, day.v)));
                    if (count === 7) {
                        arr.push(React.createElement("tr", { key: trKey++ }, temp));
                        count = 0;
                        temp = [];
                    }
                };
                for (var _i = 0, dayArr_1 = dayArr; _i < dayArr_1.length; _i++) {
                    var day = dayArr_1[_i];
                    _loop_1(day);
                }
                return arr;
            };
            var timePanelProps = (typeof showTime !== 'boolean' && showTime !== undefined) ? showTime : {};
            var timePanelFormat = timePanelProps.format || 'HH:mm:ss';
            return (React.createElement("div", { className: preCls + "-panel" },
                React.createElement("div", { className: preCls + "-input-wrap" },
                    React.createElement("input", { placeholder: placeholder, readOnly: true, value: valueR ? moment(valueR).format(format) : '' }),
                    React.createElement(Icon, { type: 'ios-close-circle', onClick: _this.onChange.bind(_this, '') })),
                React.createElement("div", { className: preCls + "-container" },
                    React.createElement("div", { className: preCls + "-header" },
                        React.createElement(Icon, { type: 'ios-rewind', className: preCls + "-year-pre", onClick: function () {
                                _this.onChange(+m.subtract(1, 'year').format('x'));
                            } }),
                        React.createElement(Icon, { type: 'md-arrow-dropleft', className: preCls + "-month-pre", onClick: function () {
                                _this.onChange(+m.subtract(1, 'month').format('x'));
                            } }),
                        React.createElement("span", { className: preCls + "-time" }, m.format('YYYY年MM月')),
                        React.createElement(Icon, { type: 'md-arrow-dropright', className: preCls + "-month-next", onClick: function () {
                                _this.onChange(+m.add(1, 'month').format('x'));
                            } }),
                        React.createElement(Icon, { type: 'ios-fastforward', className: preCls + "-year-next", onClick: function () {
                                _this.onChange(+m.add(1, 'year').format('x'));
                            } })),
                    React.createElement("div", { className: preCls + "-body" },
                        React.createElement("table", null,
                            React.createElement("thead", null,
                                React.createElement("tr", null, weekArr.map(function (item, key) { return React.createElement("th", { key: key }, item); }))),
                            React.createElement("tbody", null, renderDate()))),
                    showTime ? (React.createElement("div", { className: preCls + "-footer" },
                        React.createElement("span", { className: preCls + "-timepicker-btn", onClick: function () {
                                _this.setState({
                                    showTimePicker: !_this.state.showTimePicker,
                                });
                            } }, _this.state.showTimePicker ? '选择日期' : '选择时刻'),
                        React.createElement(Button, { size: 'small', type: 'primary', onClick: function () { return _this.onOpenChange(false); } }, "\u786E\u5B9A"))) : null,
                    _this.state.showTimePicker ? (React.createElement("div", { className: preCls + "-timepicker-box" },
                        React.createElement("div", { className: preCls + "-time-title" }, m.format('YYYY年MM月DD日')),
                        React.createElement(TimePanel, tslib_1.__assign({ value: m.format(timePanelFormat), onChange: function (v) {
                                var vm = moment(v, timePanelFormat);
                                var hour = vm.hour();
                                var minute = vm.minute();
                                var second = vm.second();
                                _this.onChange(+m.hour(hour).minute(minute).second(second).format('x'));
                            } }, timePanelProps)))) : null)));
        };
        return _this;
    }
    DatePicker.prototype.render = function () {
        var _a = this.props, className = _a.className, style = _a.style, size = _a.size, open = _a.open, defaultOpen = _a.defaultOpen, value = _a.value, defaultValue = _a.defaultValue, onChange = _a.onChange, onOpenChange = _a.onOpenChange, placeholder = _a.placeholder, disabled = _a.disabled, format = _a.format, children = _a.children, showTime = _a.showTime, otherProps = tslib_1.__rest(_a, ["className", "style", "size", "open", "defaultOpen", "value", "defaultValue", "onChange", "onOpenChange", "placeholder", "disabled", "format", "children", "showTime"]);
        var preCls = this.preCls;
        var clsName = classNames(preCls, className);
        var openR = this.getOpen();
        var valueR = this.getValue();
        return (React.createElement(PopOver, { open: openR, onOpenChange: this.onOpenChange, pop: this.renderPop() },
            React.createElement("div", tslib_1.__assign({ className: clsName, style: style }, otherProps),
                React.createElement(Input, { disabled: disabled, size: size, placeholder: placeholder, value: valueR ? moment(valueR).format(format) : '', readOnly: true }),
                React.createElement(Icon, { className: preCls + "-icon", type: 'ios-calendar' }))));
    };
    DatePicker.defaultProps = {
        size: 'default',
        placeholder: '请选择日期',
        defaultOpen: false,
        defaultValue: '',
        format: 'YYYY-MM-DD',
    };
    return DatePicker;
}(Component));
export { DatePicker };
export default DatePicker;
//# sourceMappingURL=DatePicker.js.map