import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
var sizes = ['xs', 'sm', 'md', 'lg', 'xl', 'xxl'];
/**
 * **组件中文名称**-组件描述。
 */
var Col = /** @class */ (function (_super) {
    tslib_1.__extends(Col, _super);
    function Col() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.preCls = 'yoshino-col';
        _this.getSizeCls = function () {
            var sizeCls = {};
            var preCls = _this.preCls;
            sizes.forEach(function (size) {
                var _a;
                var sizeProps = {};
                // tslint:disable-next-line
                var props = _this.props;
                if (typeof props[size] === 'number') {
                    sizeProps.span = props[size];
                }
                else if (typeof props[size] === 'object') {
                    sizeProps = props[size] || {};
                }
                sizeCls = tslib_1.__assign({}, sizeCls, (_a = {}, _a[preCls + "-" + size + "-" + sizeProps.span] = sizeProps.span !== undefined, _a[preCls + "-" + size + "-order-" + sizeProps.order] = sizeProps.order || sizeProps.order === 0, _a[preCls + "-" + size + "-offset-" + sizeProps.offset] = sizeProps.offset || sizeProps.offset === 0, _a[preCls + "-" + size + "-push-" + sizeProps.push] = sizeProps.push || sizeProps.push === 0, _a[preCls + "-" + size + "-pull-" + sizeProps.pull] = sizeProps.pull || sizeProps.pull === 0, _a));
            });
            return sizeCls;
        };
        return _this;
    }
    Col.prototype.render = function () {
        var _a;
        var _b = this.props, className = _b.className, style = _b.style, span = _b.span, offset = _b.offset, order = _b.order, pull = _b.pull, push = _b.push, children = _b.children, otherProps = tslib_1.__rest(_b, ["className", "style", "span", "offset", "order", "pull", "push", "children"]);
        var preCls = this.preCls;
        var sizeCls = this.getSizeCls();
        var clsName = classNames(preCls, className, sizeCls, (_a = {},
            _a[preCls + "-" + span] = span !== undefined,
            _a[preCls + "-order-" + order] = !!order,
            _a[preCls + "-offset-" + offset] = !!offset,
            _a[preCls + "-push-" + push] = !!push,
            _a[preCls + "-pull-" + pull] = !!pull,
            _a));
        return (React.createElement("div", tslib_1.__assign({ className: clsName, style: style }, otherProps), children));
    };
    Col.defaultProps = {
        offset: 0,
        order: 0,
        pull: 0,
        push: 0,
    };
    return Col;
}(Component));
export { Col };
export default Col;
//# sourceMappingURL=Col.js.map