import { Component } from 'react';
import { IBaseComponent } from '../template/component';
export interface IIconProps extends IBaseComponent {
    /**
     * 图标名称
     */
    type?: string;
    /**
     * 渲染svg
     */
    svg?: string;
}
export interface IIconState {
    svgHtml: string;
}
/**
 * **图标**-展示对应的矢量化图标。
 */
export declare class Icon extends Component<IIconProps, IIconState> {
    state: {
        svgHtml: string;
    };
    getSvg: (type: string) => Promise<string>;
    componentDidMount(): Promise<void>;
    componentWillReceiveProps(props: IIconProps): Promise<void>;
    render(): JSX.Element;
}
export default Icon;
