import * as tslib_1 from "tslib";
// tslint:disable
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
/**
 * **输入框**-用于获取用书通过键盘输入的内容
 */
var Input = /** @class */ (function (_super) {
    tslib_1.__extends(Input, _super);
    function Input() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: _this.props.defaultValue,
        };
        _this.getValue = function () {
            var value = _this.props.value;
            return value !== undefined ? value : _this.state.value;
        };
        _this.onChange = function (e) {
            var _a = _this.props, onChange = _a.onChange, disabled = _a.disabled;
            var value = e.target.value;
            if (disabled) {
                return;
            }
            if (onChange) {
                onChange(value);
            }
            _this.setState({ value: value });
        };
        _this.onEnter = function (e) {
            var _a = _this.props, onEnter = _a.onEnter, onKeyDown = _a.onKeyDown;
            if (e.keyCode === 13 && onEnter) {
                onEnter();
            }
            if (onKeyDown) {
                onKeyDown(e);
            }
        };
        return _this;
    }
    Input.prototype.render = function () {
        var _a, _b;
        var _c = this.props, className = _c.className, style = _c.style, size = _c.size, header = _c.header, footer = _c.footer, headerStyle = _c.headerStyle, footerStyle = _c.footerStyle, onEnter = _c.onEnter, onChange = _c.onChange, value = _c.value, defaultValue = _c.defaultValue, refInput = _c.refInput, disabled = _c.disabled, compact = _c.compact, otherProps = tslib_1.__rest(_c, ["className", "style", "size", "header", "footer", "headerStyle", "footerStyle", "onEnter", "onChange", "value", "defaultValue", "refInput", "disabled", "compact"]);
        var preCls = 'yoshino-input';
        var clsName = classNames(preCls + "-wrapper", preCls + "-" + size, className, (_a = {},
            _a[preCls + "-compact"] = compact,
            _a));
        var inputCls = classNames(preCls, (_b = {},
            _b[preCls + "-disabled"] = disabled,
            _b[preCls + "-enabled"] = !disabled,
            _b));
        var inValue = this.getValue();
        return (React.createElement("span", { className: clsName, style: style },
            header ? (React.createElement("span", { className: preCls + "-header", style: headerStyle }, header)) : null,
            React.createElement("input", tslib_1.__assign({ type: 'text', className: inputCls }, otherProps, { onKeyDown: this.onEnter, onChange: this.onChange, value: inValue, ref: refInput, disabled: disabled })),
            footer ? (React.createElement("span", { className: preCls + "-footer", style: footerStyle }, footer)) : null));
    };
    Input.defaultProps = {
        size: 'default',
        defaultValue: '',
        disabled: false,
        compact: false,
    };
    return Input;
}(Component));
export { Input };
export default Input;
//# sourceMappingURL=Input.js.map