import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
import Icon from '../Icon';
import * as loadingSVG from './loadSvg';
/**
 * **加载**-表示当前处于加载状态中。
 */
var Loading = /** @class */ (function (_super) {
    tslib_1.__extends(Loading, _super);
    function Loading() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Loading.prototype.render = function () {
        var _a, _b;
        var _c = this.props, className = _c.className, style = _c.style, children = _c.children, type = _c.type, color = _c.color, size = _c.size, text = _c.text, icon = _c.icon, loading = _c.loading, otherProps = tslib_1.__rest(_c, ["className", "style", "children", "type", "color", "size", "text", "icon", "loading"]);
        var preCls = 'yoshino-loading';
        var sizeObj = {
            small: 14,
            default: 20,
            large: 32,
            auto: '1em',
        };
        // const fontSize = !!style && style.fontSize !== undefined && Number(style.fontSize);
        var radius = sizeObj[size];
        var iconType = loadingSVG[type](radius, radius, color);
        var loadSize = preCls + "-" + size;
        var hasChildren = !!children;
        var clsName = classNames(preCls, className, (_a = {},
            _a[preCls + "-children-box"] = hasChildren,
            _a));
        return (React.createElement("div", tslib_1.__assign({ className: clsName, style: style }, otherProps),
            hasChildren ? React.createElement("div", { className: preCls + "-children" }, children) : null,
            loading ? (React.createElement(React.Fragment, null,
                React.createElement("div", { className: classNames(preCls + "-container", loadSize, (_b = {},
                        _b[preCls + "-children-container"] = hasChildren,
                        _b)) },
                    React.createElement("span", { className: preCls + "-icon" }, icon ? icon : React.createElement(Icon, { svg: iconType })),
                    text ? (React.createElement("p", { className: preCls + "-text" }, typeof text === 'string' ? text : '加载中')) : null),
                hasChildren ? React.createElement("div", { className: preCls + "-mask" }) : null)) : null));
    };
    Loading.defaultProps = {
        type: 'a',
        size: 'auto',
        text: false,
        loading: true,
        color: 'currentColor',
    };
    return Loading;
}(Component));
export { Loading };
export default Loading;
//# sourceMappingURL=Loading.js.map