import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
/**
 * **菜单**-提供导航功能
 */
var Menu = /** @class */ (function (_super) {
    tslib_1.__extends(Menu, _super);
    function Menu() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        // 不使用原生context的原因是因为水平模式下，pop层渲染在根节点下，context会丢失
        _this.getCtx = function () {
            return {
                mode: _this.props.mode,
                activeKey: _this.getActiveKey(),
                openKeys: _this.getOpenKeys(),
                onSelect: _this.onSelect,
                onOpenChange: _this.onOpenChange,
                offset: _this.props.offset,
            };
        };
        _this.state = {
            activeKey: _this.props.defaultActiveKey,
            openKeys: _this.props.defaultOpenKeys,
        };
        _this.getActiveKey = function () {
            var activeKey = _this.props.activeKey;
            return activeKey === undefined ? _this.state.activeKey : activeKey;
        };
        _this.onSelect = function (key) {
            _this.onSelectTrigger(key);
        };
        _this.onSelectTrigger = function (activeKey) {
            if (activeKey === _this.getActiveKey()) {
                return;
            }
            var onSelect = _this.props.onSelect;
            if (onSelect) {
                onSelect(activeKey);
            }
            _this.setState({
                activeKey: activeKey,
            });
        };
        _this.getOpenKeys = function () {
            var openKeys = _this.props.openKeys;
            return openKeys === undefined ? _this.state.openKeys : openKeys;
        };
        _this.onOpenChange = function (openKey) {
            var openKeys = _this.getOpenKeys();
            if (openKeys.indexOf(openKey) !== -1) {
                openKeys.splice(openKeys.indexOf(openKey), 1);
            }
            else {
                openKeys.push(openKey);
            }
            _this.onOpenChangeTrigger(openKeys);
        };
        _this.onOpenChangeTrigger = function (openKeys) {
            var onOpenChange = _this.props.onOpenChange;
            if (onOpenChange) {
                onOpenChange(openKeys);
            }
            _this.setState({
                openKeys: openKeys,
            });
        };
        return _this;
    }
    Menu.prototype.render = function () {
        var _this = this;
        var _a = this.props, className = _a.className, style = _a.style, children = _a.children, onSelect = _a.onSelect, defaultActiveKey = _a.defaultActiveKey, onOpenChange = _a.onOpenChange, defaultOpenKeys = _a.defaultOpenKeys, offset = _a.offset, activeKey = _a.activeKey, mode = _a.mode, openKeys = _a.openKeys, otherProps = tslib_1.__rest(_a, ["className", "style", "children", "onSelect", "defaultActiveKey", "onOpenChange", "defaultOpenKeys", "offset", "activeKey", "mode", "openKeys"]);
        var preCls = 'yoshino-menu';
        var clsName = classNames(preCls, preCls + "-" + mode, className);
        return (React.createElement("ul", tslib_1.__assign({ className: clsName, style: style }, otherProps), 
        // tslint:disable
        React.Children.map(children, function (child) {
            return React.cloneElement(child, {
                deep: 1,
                ctx: _this.getCtx(),
                keyId: child.key,
            });
        })));
    };
    Menu.defaultProps = {
        defaultActiveKey: '',
        defaultOpenKeys: [],
        offset: 24,
        mode: 'vertical',
    };
    return Menu;
}(Component));
export { Menu };
export default Menu;
//# sourceMappingURL=Menu.js.map