import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
import Transitions from '../Transitions';
import Icon from '../Icon';
import Pop from '../Pop';
var Expand = Transitions.Expand;
/**
 * **菜单**-提供导航功能
 */
var SubMenu = /** @class */ (function (_super) {
    tslib_1.__extends(SubMenu, _super);
    function SubMenu() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            childMenuVisible: false,
        };
        _this.onOpenChange = function () {
            var _a = _this.props, keyId = _a.keyId, disabled = _a.disabled, ctx = _a.ctx;
            var onOpenChange = ctx.onOpenChange;
            if (disabled) {
                return;
            }
            if (onOpenChange) {
                onOpenChange(keyId);
            }
        };
        return _this;
    }
    SubMenu.prototype.render = function () {
        var _this = this;
        var _a;
        var _b = this.props, className = _b.className, style = _b.style, children = _b.children, title = _b.title, deep = _b.deep, keyId = _b.keyId, disabled = _b.disabled, ctx = _b.ctx, otherProps = tslib_1.__rest(_b, ["className", "style", "children", "title", "deep", "keyId", "disabled", "ctx"]);
        var _c = ctx.openKeys, openKeys = _c === void 0 ? [] : _c, offset = ctx.offset, mode = ctx.mode;
        var preCls = 'yoshino-sub-menu';
        var isVertical = mode === 'vertical';
        var show = !isVertical && deep > 1 ? this.state.childMenuVisible : openKeys.indexOf(keyId) !== -1;
        var clsName = classNames(preCls, className, (_a = {},
            _a[preCls + "-hidden"] = !show,
            _a[preCls + "-disabled"] = disabled,
            _a));
        var paddingLeft = isVertical ? deep * offset + "px" : '';
        var action = isVertical ? {
            onClick: this.onOpenChange,
        } : {};
        var liAction = !isVertical && deep > 1 ? {
            onMouseEnter: function () { return _this.setState({ childMenuVisible: true }); },
            onMouseLeave: function () { return _this.setState({ childMenuVisible: false }); },
        } : {};
        var containerJSX = (React.createElement(Expand, { timeout: 300, active: show },
            React.createElement("div", { className: preCls + "-container" },
                React.createElement("ul", { className: preCls + "-list" }, 
                // tslint:disable
                React.Children.map(children, function (child) {
                    return React.cloneElement(child, {
                        deep: deep + 1,
                        ctx: ctx,
                        keyId: child.key,
                    });
                })))));
        var titleJSX = (React.createElement("div", tslib_1.__assign({ className: preCls + "-title", style: { paddingLeft: paddingLeft } }, action),
            title,
            isVertical ? React.createElement(Icon, { type: 'ios-arrow-up', className: preCls + "-icon" }) : null));
        return (React.createElement(React.Fragment, null,
            React.createElement("li", tslib_1.__assign({ className: clsName, style: style }, otherProps, liAction), isVertical ? (React.createElement(React.Fragment, null,
                titleJSX,
                containerJSX)) : deep === 1 ? (React.createElement(Pop, { content: containerJSX, overlayClassName: preCls + "-pop-list", placement: 'bottomLeft', trigger: 'hoverClick', inheritWidth: true, isMinWidth: true, onChangeBefore: function () {
                    _this.onOpenChange();
                } }, titleJSX)) : (React.createElement(React.Fragment, null,
                titleJSX,
                deep > 1 ? (
                // 这里加一层为了避免鼠标移入子菜单的时候出发onMouseLeave事件
                React.createElement("div", { className: preCls + "-child-menu-container" },
                    React.createElement("div", { className: preCls + "-child-menu" }, containerJSX))) : null)))));
    };
    SubMenu.defaultProps = {
        disabled: false,
    };
    return SubMenu;
}(Component));
export { SubMenu };
export default SubMenu;
//# sourceMappingURL=SubMenu.js.map