import * as React from 'react';
import { ReactNode } from 'react';
import { IBaseComponent } from '../template/component';
export declare type TType = 'success' | 'info' | 'warning' | 'error';
export interface IMessage {
    key?: string | number;
    duration?: number;
    content: ReactNode | string;
    onClose?: () => void;
    icon?: React.ReactNode;
}
export interface IMessageComponent extends IMessage, IBaseComponent {
    visible?: boolean;
    type: TType;
}
export interface IMessageConfig {
    top?: number;
    duration?: number;
}
export declare class Message extends React.Component<IMessageComponent> {
    render(): JSX.Element;
}
declare const _default: {
    config: (props: IMessageConfig) => void;
    success: (props: string | IMessage) => void;
    info: (props: string | IMessage) => void;
    warn: (props: string | IMessage) => void;
    error: (props: string | IMessage) => void;
    close: (key: string | number) => void;
    destroy: () => void;
};
export default _default;
