import { Component } from 'react';
import * as React from 'react';
import { IBaseComponent } from '../template/component';
import { IButtonProps } from '../Button/Button';
export interface IModalProps extends IBaseComponent {
    zIndex?: number;
    width?: number;
    onOk?: () => boolean;
    onCancel?: () => void;
    onClose?: () => void;
    okText?: React.ReactNode;
    okButtonProps?: IButtonProps;
    cancelText?: React.ReactNode;
    cancelButtonProps?: IButtonProps;
    showCancel?: boolean;
    closeText?: React.ReactNode;
    showOk?: boolean;
    showClose?: boolean;
    title?: React.ReactNode;
    content?: React.ReactNode;
    bodyContent?: React.ReactNode;
    icon?: React.ReactNode;
    showMask?: boolean;
    maskClosable?: boolean;
    maskClick?: () => void;
    maskStyle?: React.CSSProperties;
}
export interface IModalComponentProps extends IModalProps {
    type?: 'success' | 'error' | 'warning' | 'confirm' | 'info';
    visible?: boolean;
}
export interface IModalComponentState {
    visible: boolean;
}
/**
 * **组件中文名称**-组件描述。
 */
declare class Modal extends Component<IModalComponentProps, IModalComponentState> {
    static confirm: (props: IModalProps) => {
        div: HTMLDivElement;
        modal: JSX.Element;
    };
    static info: (props: IModalProps) => {
        div: HTMLDivElement;
        modal: JSX.Element;
    };
    static success: (props: IModalProps) => {
        div: HTMLDivElement;
        modal: JSX.Element;
    };
    static error: (props: IModalProps) => {
        div: HTMLDivElement;
        modal: JSX.Element;
    };
    static warning: (props: IModalProps) => {
        div: HTMLDivElement;
        modal: JSX.Element;
    };
    static warn: (props: IModalProps) => {
        div: HTMLDivElement;
        modal: JSX.Element;
    };
    static close: (obj: {
        div: HTMLDivElement;
        modal: JSX.Element;
    }) => boolean;
    static defaultProps: {
        zIndex: number;
        width: number;
        showCancel: boolean;
        showClose: boolean;
        showMask: boolean;
        showOk: boolean;
        maskClosable: boolean;
        type: string;
    };
    state: {
        visible: boolean;
    };
    componentWillUnmount(): void;
    onCancel: () => void;
    onOk: () => void;
    onClose: () => void;
    getVisible: () => boolean;
    render(): JSX.Element | null;
}
export default Modal;
