import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
import Button from '../Button';
import Icon from '../Icon';
import { render, unmountComponentAtNode } from 'react-dom';
import { Dialog } from '../utils/';
/**
 * **组件中文名称**-组件描述。
 */
var Modal = /** @class */ (function (_super) {
    tslib_1.__extends(Modal, _super);
    function Modal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            visible: true,
        };
        _this.onCancel = function () {
            var onCancel = _this.props.onCancel;
            if (onCancel) {
                onCancel();
            }
            _this.onClose();
        };
        _this.onOk = function () {
            var onOk = _this.props.onOk;
            if (onOk) {
                if (onOk()) {
                    _this.onClose();
                }
            }
            else {
                _this.onClose();
            }
        };
        _this.onClose = function () {
            var onClose = _this.props.onClose;
            if (onClose) {
                onClose();
            }
            _this.setState({
                visible: false,
            });
        };
        _this.getVisible = function () {
            var visible = _this.props.visible;
            var result = visible !== undefined ? visible : _this.state.visible;
            if (result) {
                document.documentElement.style.overflow = 'hidden';
                document.documentElement.style.height = '100vh';
            }
            else {
                document.documentElement.style.overflow = null;
                document.documentElement.style.height = null;
            }
            return result;
        };
        return _this;
    }
    Modal.prototype.componentWillUnmount = function () {
        document.documentElement.style.overflow = null;
        document.documentElement.style.height = null;
    };
    Modal.prototype.render = function () {
        var _this = this;
        var _a = this.props, className = _a.className, style = _a.style, title = _a.title, bodyContent = _a.bodyContent, visible = _a.visible, content = _a.content, icon = _a.icon, width = _a.width, zIndex = _a.zIndex, showCancel = _a.showCancel, okText = _a.okText, cancelText = _a.cancelText, _b = _a.type, type = _b === void 0 ? 'confirm' : _b, closeText = _a.closeText, showClose = _a.showClose, maskStyle = _a.maskStyle, maskClosable = _a.maskClosable, showMask = _a.showMask, maskClick = _a.maskClick, onOk = _a.onOk, onCancel = _a.onCancel, children = _a.children, okButtonProps = _a.okButtonProps, cancelButtonProps = _a.cancelButtonProps, showOk = _a.showOk, otherProps = tslib_1.__rest(_a, ["className", "style", "title", "bodyContent", "visible", "content", "icon", "width", "zIndex", "showCancel", "okText", "cancelText", "type", "closeText", "showClose", "maskStyle", "maskClosable", "showMask", "maskClick", "onOk", "onCancel", "children", "okButtonProps", "cancelButtonProps", "showOk"]);
        var preCls = 'yoshino-modal';
        var clsName = classNames(preCls, className);
        var iconType = {
            success: 'md-checkmark-circle',
            info: 'md-information-circle',
            warning: 'md-alert',
            error: 'md-close-circle',
        };
        var hasIcon = type !== 'confirm' || icon;
        var visibleR = this.getVisible();
        var conetnt = children || bodyContent;
        var okTextIsString = typeof okText === 'string' || okText === undefined;
        var cancelTextIsString = typeof cancelText === 'string' || cancelText === undefined;
        return visibleR ? (React.createElement(Dialog, { visible: visibleR, showMask: showMask, maskStyle: maskStyle, maskClick: function () {
                if (maskClosable) {
                    _this.onClose();
                }
                if (maskClick) {
                    maskClick();
                }
            } },
            React.createElement("div", tslib_1.__assign({ className: clsName, style: tslib_1.__assign({ width: width, zIndex: zIndex }, style) }, otherProps),
                showClose ? React.createElement("div", { className: preCls + "-close", onClick: this.onClose }, closeText || React.createElement(Icon, { type: 'md-close' })) : null,
                React.createElement("div", { className: preCls + "-body" }, conetnt ? conetnt : (React.createElement(React.Fragment, null,
                    type !== 'confirm' || icon ? (React.createElement("div", { className: preCls + "-icon " + preCls + "-icon-" + type }, icon ? icon : type !== 'confirm' ? React.createElement(Icon, { type: iconType[type] }) : null)) : null,
                    React.createElement("div", { className: preCls + "-word-container " + (!hasIcon ? preCls + "-word-container-no-icon" : '') },
                        React.createElement("div", { className: preCls + "-title" }, title),
                        React.createElement("div", { className: preCls + "-content" }, content))))),
                React.createElement("div", { className: preCls + "-footer" },
                    type === 'confirm' && showCancel ? (React.createElement("div", { className: preCls + "-cancel", onClick: !cancelTextIsString ? this.onCancel : undefined }, cancelTextIsString ? (React.createElement(Button, tslib_1.__assign({}, cancelButtonProps, { onClick: this.onCancel }), cancelText || '取消')) : cancelText)) : null,
                    showOk ? (React.createElement("div", { className: preCls + "-ok", onClick: !okTextIsString ? this.onOk : undefined }, okTextIsString ? (React.createElement(Button, tslib_1.__assign({ type: 'primary' }, okButtonProps, { onClick: this.onOk }), okText ? okText : type !== 'confirm' ? '知道了' : '确定')) : okText)) : null)))) : null;
    };
    Modal.defaultProps = {
        zIndex: 1000,
        width: 256,
        showCancel: true,
        showClose: false,
        showMask: true,
        showOk: true,
        maskClosable: true,
        type: 'confirm',
    };
    return Modal;
}(Component));
var renderModal = function (props) {
    var div = document.createElement('div');
    var _a = props.maskClosable, maskClosable = _a === void 0 ? true : _a, maskClick = props.maskClick;
    document.body.appendChild(div);
    var modal = (React.createElement(Modal, tslib_1.__assign({}, props, { onClose: function () {
            var onClose = props.onClose;
            if (onClose) {
                onClose();
            }
            closeModal({ div: div, modal: modal });
        }, maskClick: function () {
            if (maskClosable) {
                closeModal({ div: div, modal: modal });
            }
            if (maskClick) {
                maskClick();
            }
        } })));
    render(modal, div);
    return { div: div, modal: modal };
};
var closeModal = function (obj) {
    try {
        unmountComponentAtNode(obj.div);
        document.body.removeChild(obj.div);
    }
    catch (error) {
        return false;
    }
    return true;
};
Modal.confirm = function (props) { return renderModal(tslib_1.__assign({ type: 'confirm' }, props)); };
Modal.info = function (props) { return renderModal(tslib_1.__assign({ type: 'info' }, props)); };
Modal.success = function (props) { return renderModal(tslib_1.__assign({ type: 'success' }, props)); };
Modal.error = function (props) { return renderModal(tslib_1.__assign({ type: 'error' }, props)); };
Modal.warning = Modal.warn = function (props) { return renderModal(tslib_1.__assign({ type: 'warning' }, props)); };
Modal.close = closeModal;
export default Modal;
//# sourceMappingURL=Modal.js.map