import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as classNames from 'classnames';
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { RenderInRootDom } from '../utils/';
/**
 * **组件中文名称**-组件描述。
 */
var Pop = /** @class */ (function (_super) {
    tslib_1.__extends(Pop, _super);
    function Pop() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.animateTimeHandle = []; // 动画timeout句柄
        _this.popId = "pop_" + new Date().getTime() * Math.random(); // pop唯一id
        _this.state = {
            visible: _this.props.defaultVisible,
        };
        _this.renderPop = function () {
            var _a = _this.props, className = _a.className, children = _a.children, style = _a.style, defaultVisible = _a.defaultVisible, placement = _a.placement, overlayStyle = _a.overlayStyle, overlayClassName = _a.overlayClassName, mouseEnterDelay = _a.mouseEnterDelay, mouseLeaveDelay = _a.mouseLeaveDelay, mountOnEnter = _a.mountOnEnter, onChange = _a.onChange, content = _a.content, visible = _a.visible, inheritWidth = _a.inheritWidth, onChangeBefore = _a.onChangeBefore, isMinWidth = _a.isMinWidth, focusOnce = _a.focusOnce, otherProps = tslib_1.__rest(_a, ["className", "children", "style", "defaultVisible", "placement", "overlayStyle", "overlayClassName", "mouseEnterDelay", "mouseLeaveDelay", "mountOnEnter", "onChange", "content", "visible", "inheritWidth", "onChangeBefore", "isMinWidth", "focusOnce"]);
            var preCls = 'yoshino-pop';
            var clsName = classNames(preCls, _this.popId, preCls + "-" + placement, overlayClassName, className);
            var child = React.Children.only(content);
            return (_this.getVisible() ? (React.createElement(RenderInRootDom, { callBack: _this.resetPopPostion },
                React.createElement("div", tslib_1.__assign({ className: clsName, style: tslib_1.__assign({}, overlayStyle), tabIndex: 0 }, otherProps, _this.getConentTriggerAction()), child)))
                : null);
        };
        _this.resetPopPostion = function () {
            var children = ReactDOM.findDOMNode(_this.refChildren);
            var _a = _this.props, _b = _a.placement, placement = _b === void 0 ? 'top' : _b, inheritWidth = _a.inheritWidth, isMinWidth = _a.isMinWidth;
            var dom = document.getElementsByClassName(_this.popId)[0];
            var domRectReal = dom.getBoundingClientRect(); // Pop - content -  dom
            var rect = children.getBoundingClientRect(); // Pop - target - dom
            var pageY = window.pageYOffset; // 当前滚动条y轴偏移量
            var pageX = window.pageXOffset; // 当前滚动条x轴偏移量
            var childrenX = pageX + rect.left; // 子元素x
            var childrenY = pageY + rect.top; // 子元素y
            // 解决部分浏览器rect不可修改的问题
            var domRect = {
                width: inheritWidth ? rect.width : domRectReal.width,
                height: domRectReal.height,
            };
            // placement所对应的left top
            var config = {
                top: { left: childrenX + rect.width / 2 - domRect.width / 2, top: childrenY - domRect.height },
                left: { left: childrenX - domRect.width, top: childrenY + rect.height / 2 - domRect.height / 2 },
                bottom: { left: childrenX + rect.width / 2 - domRect.width / 2, top: childrenY + rect.height },
                right: { left: childrenX + rect.width, top: childrenY + rect.height / 2 - domRect.height / 2 },
                topLeft: { left: childrenX, top: childrenY - domRect.height },
                topRight: { left: childrenX + rect.width - domRect.width, top: childrenY - domRect.height },
                leftTop: { left: childrenX - domRect.width, top: childrenY },
                leftBottom: { left: childrenX - domRect.width, top: childrenY + rect.height - domRect.height },
                bottomLeft: { left: childrenX, top: childrenY + rect.height },
                bottomRight: { left: childrenX + rect.width - domRect.width, top: childrenY + rect.height },
                rightTop: { left: childrenX + rect.width, top: childrenY },
                rightBottom: { left: childrenX + rect.width, top: childrenY + rect.height - domRect.height },
            };
            dom.style.top = config[placement].top + 'px';
            dom.style.left = config[placement].left + 'px';
            if (inheritWidth) {
                if (isMinWidth) {
                    dom.style.minWidth = rect.width + 'px';
                }
                else {
                    dom.style.width = rect.width + 'px';
                }
            }
        };
        _this.getVisible = function () {
            var visible = _this.props.visible;
            return visible === undefined ? _this.state.visible : visible;
        };
        _this.onChangeTrigger = function (visible) {
            var _a = _this.props, onChange = _a.onChange, mouseEnterDelay = _a.mouseEnterDelay, mouseLeaveDelay = _a.mouseLeaveDelay, onChangeBefore = _a.onChangeBefore;
            if (_this.timeoutHandle !== undefined) {
                clearTimeout(_this.timeoutHandle);
            }
            if (visible === _this.state.visible) {
                return;
            }
            _this.timeoutHandle = window.setTimeout(function () {
                if (onChange) {
                    onChange(visible);
                }
                _this.setState({ visible: visible });
            }, visible ? mouseEnterDelay : mouseLeaveDelay);
            if (onChangeBefore) {
                onChangeBefore(visible);
            }
        };
        _this.toggleVisible = function (visible) {
            if (_this.timueoutFoucs) {
                clearTimeout(_this.timueoutFoucs);
            }
            _this.timueoutFoucs = window.setTimeout(function () {
                _this.onChangeTrigger(visible);
            }, 10);
        };
        // pop包裹对象trigger表现
        _this.getTargetTriggerAction = function () {
            var show = _this.toggleVisible.bind(_this, true);
            var hide = _this.toggleVisible.bind(_this, false);
            var _a = _this.props.trigger, trigger = _a === void 0 ? 'hover' : _a;
            var action = {
                hover: {
                    onMouseEnter: show,
                    onMouseLeave: hide,
                },
                hoverClick: {
                    onMouseEnter: show,
                    onMouseLeave: hide,
                },
                focus: {
                    onFocus: show,
                    onBlur: hide,
                },
                click: {
                    onClick: _this.getVisible() ? hide : show,
                },
            };
            return action[trigger];
        };
        // pop - content triggert表现
        _this.getConentTriggerAction = function () {
            var show = _this.toggleVisible.bind(_this, true);
            var hide = _this.toggleVisible.bind(_this, false);
            var _a = _this.props, _b = _a.trigger, trigger = _b === void 0 ? 'hover' : _b, focusOnce = _a.focusOnce;
            var action = {
                hover: {
                    onMouseEnter: show,
                    onMouseLeave: hide,
                },
                focus: {
                    onFocus: show,
                    onBlur: hide,
                    onClick: function () {
                        if (focusOnce) {
                            hide();
                        }
                    }
                },
                click: {},
                hoverClick: {
                    onMouseEnter: show,
                    onMouseLeave: hide,
                    onClick: hide,
                }
            };
            return action[trigger];
        };
        return _this;
    }
    Pop.prototype.render = function () {
        var _this = this;
        var children = this.props.children;
        // tslint:disable
        var child = React.Children.only(children);
        return React.cloneElement(child, tslib_1.__assign({ 
            // tslint:disable:no-any
            ref: function (v) {
                if (v) {
                    _this.refChildren = v;
                    if (child.ref) {
                        child.ref(v);
                    }
                }
            } }, this.getTargetTriggerAction()), child.props.children, this.renderPop());
    };
    Pop.defaultProps = {
        placement: 'top',
        mouseEnterDelay: 0,
        mouseLeaveDelay: 100,
        trigger: 'hover',
        overlayClassName: '',
        overlayStyle: {},
        defaultVisible: false,
        mountOnEnter: false,
        inheritWidth: false,
        isMinWidth: false,
        focusOnce: false,
    };
    return Pop;
}(Component));
export { Pop };
export default Pop;
//# sourceMappingURL=Pop.js.map