import { Component } from 'react';
import { IBaseComponent } from '../template/component';
export interface IPopOverProps extends IBaseComponent {
    /**
     * 面板是否展开
     */
    open: boolean;
    /**
     * 面板展开回调
     */
    onOpenChange?: (v: boolean) => void;
    /**
     * 浮层内容
     */
    pop: any;
    /**
     * 进入后
     */
    onEntered?: () => void;
    /**
     * 浮层消失后是否销毁
     */
    unmountOnExit?: boolean;
}
export interface IPopOverState {
    popPos: {
        left: number;
        top: number;
    };
}
/**
 * **组件中文名称**-组件描述。
 */
export declare class PopOver extends Component<IPopOverProps, IPopOverState> {
    preCls: string;
    refPopOverContainer: Element;
    static defaultProps: {
        unmountOnExit: boolean;
    };
    state: {
        popPos: {
            left: number;
            top: number;
        };
    };
    componentDidMount(): void;
    setPopOverPosition: () => void;
    onOpenChange: (open: boolean) => void;
    render(): JSX.Element;
}
export default PopOver;
