import { Component } from 'react';
import { IBaseComponent } from '../template/component';
export interface IProgressProps extends IBaseComponent {
    /**
     * 进度条背景色
     */
    bgColor?: string;
    /**
     * 进度条颜色
     */
    strokeColor?: string;
    /**
     * 当前百分比
     */
    percent: number;
    /**
     * 进度条类型
     */
    type?: 'line' | 'circle';
    /**
     * 直径
     */
    diameter?: number;
    /**
     * 进度条宽度
     */
    strokeWidth?: number;
    /**
     * 内容模板
     */
    format?: (percent: number) => string;
}
export interface IProgressState {
}
/**
 * **进度条**-展示当前操作流程进度。
 */
export declare class Progress extends Component<IProgressProps, IProgressState> {
    preCls: string;
    static defaultProps: {
        percent: number;
        type: string;
        diameter: number;
    };
    getPercent: () => number;
    renderCircle: () => JSX.Element;
    render(): JSX.Element;
}
export default Progress;
