import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
/**
 * **进度条**-展示当前操作流程进度。
 */
var Progress = /** @class */ (function (_super) {
    tslib_1.__extends(Progress, _super);
    function Progress() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.preCls = 'yoshino-progress';
        _this.getPercent = function () {
            var percent = _this.props.percent;
            if (percent < 0) {
                return 0;
            }
            if (percent > 100) {
                return 100;
            }
            return percent;
        };
        _this.renderCircle = function () {
            var _a = _this.props, diameter = _a.diameter, _b = _a.strokeWidth, strokeWidth = _b === void 0 ? 8 : _b, strokeColor = _a.strokeColor, bgColor = _a.bgColor, format = _a.format;
            var percent = _this.getPercent();
            var o = diameter / 2;
            var r = (diameter - strokeWidth) / 2;
            var strokeDashArray = 2 * Math.PI * r;
            var strokeDashOffset = (strokeDashArray * (100 - percent)) / 100;
            return (React.createElement(React.Fragment, null,
                React.createElement("svg", { className: _this.preCls + "-svg", viewBox: "0 0 " + diameter + " " + diameter },
                    React.createElement("circle", { cx: o, cy: o, r: r, fill: 'none', strokeWidth: strokeWidth, stroke: bgColor }),
                    React.createElement("circle", { className: _this.preCls + "-svg-circle", cx: o, cy: o, r: r, fill: 'none', style: strokeColor ? { stroke: strokeColor } : {}, stroke: strokeColor, strokeWidth: strokeWidth, strokeDasharray: strokeDashArray, strokeDashoffset: strokeDashOffset })),
                React.createElement("span", { className: _this.preCls + "-circle-value", style: { fontSize: diameter / 5 } }, format ? format(percent) : percent + "%")));
        };
        return _this;
    }
    Progress.prototype.render = function () {
        var _a = this.props, className = _a.className, style = _a.style, format = _a.format, strokeColor = _a.strokeColor, bgColor = _a.bgColor, type = _a.type, _b = _a.strokeWidth, strokeWidth = _b === void 0 ? 6 : _b, diameter = _a.diameter, otherProps = tslib_1.__rest(_a, ["className", "style", "format", "strokeColor", "bgColor", "type", "strokeWidth", "diameter"]);
        var preCls = this.preCls;
        var clsName = classNames(preCls, className, preCls + "-" + type);
        var bgColorStyle = bgColor ? { backgroundColor: bgColor } : {};
        var strokeColorStyle = strokeColor ? { backgroundColor: strokeColor } : {};
        var circleStyle = type === 'circle' ? { width: diameter, height: diameter } : {};
        var lineHeightStyle = type === 'line' ? { height: strokeWidth } : {};
        var percent = this.getPercent();
        delete otherProps.percent;
        return (React.createElement("div", tslib_1.__assign({ className: clsName, style: tslib_1.__assign({}, style, bgColorStyle, circleStyle, lineHeightStyle) }, otherProps),
            type === 'line' ? React.createElement("div", { className: preCls + "-bar", style: tslib_1.__assign({ width: percent + "%" }, strokeColorStyle) }) : null,
            type === 'circle' ? this.renderCircle() : null));
    };
    Progress.defaultProps = {
        percent: 0,
        type: 'line',
        diameter: 120,
    };
    return Progress;
}(Component));
export { Progress };
export default Progress;
//# sourceMappingURL=Progress.js.map