import * as tslib_1 from "tslib";
// tslint:disable no-any
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
import Tag from '../Tag';
import Option from './Option';
import OptGroup from './OptGroup';
import Pop from '../Pop';
import Transitions from '../Transitions';
import Icon from '../Icon';
var Expand = Transitions.Expand;
/**
 * **组件中文名称**-组件描述。
 */
var Select = /** @class */ (function (_super) {
    tslib_1.__extends(Select, _super);
    function Select(props) {
        var _this = _super.call(this, props) || this;
        _this.toggleTimeOutHandle = 0;
        // 子代value -> text 的 map
        _this.mapArr = [];
        // 动画时间
        _this.timeout = 300;
        _this.state = {
            value: _this.props.defaultValue,
            visible: false,
        };
        _this.getValue = function () {
            var value = _this.props.value;
            return value !== undefined ? value : _this.state.value;
        };
        _this.onChange = function (value) {
            _this.onChangeTrigger(value);
        };
        _this.onChangeTrigger = function (value) {
            var _a = _this.props, onChange = _a.onChange, mode = _a.mode;
            var values = _this.getValue();
            var newValue;
            // 单选模式
            if (mode === 'single') {
                newValue = value;
            }
            else {
                if (!Array.isArray(values)) {
                    return;
                }
                if (values.indexOf(value) !== -1) {
                    values.splice(values.indexOf(value), 1);
                }
                else {
                    values.push(value);
                }
                newValue = values.concat();
            }
            if (onChange) {
                onChange(newValue);
            }
            _this.setState({
                value: newValue,
            });
        };
        _this.toggleVisible = function (visible) {
            if (_this.toggleTimeOutHandle) {
                clearTimeout(_this.toggleTimeOutHandle);
            }
            _this.setState({ visible: visible });
        };
        _this.value2Text = function (v) {
            var children = _this.props.children;
            var mapArr = [];
            React.Children.forEach(children, function (ele) {
                if (ele.props.label !== undefined) {
                    if (Array.isArray(ele.props.children)) {
                        React.Children.forEach(ele.props.children, function (opt) {
                            mapArr.push({ value: opt.props.value, text: opt.props.children });
                        });
                    }
                    else {
                        var opt = ele.props;
                        mapArr.push({ value: opt.value, text: opt.children });
                    }
                }
                else {
                    var opt = ele.props;
                    mapArr.push({ value: opt.value, text: opt.children });
                }
            });
            for (var _i = 0, mapArr_1 = mapArr; _i < mapArr_1.length; _i++) {
                var item = mapArr_1[_i];
                if (item.value === v) {
                    return item.text;
                }
            }
            return '';
        };
        return _this;
    }
    Select.prototype.render = function () {
        var _this = this;
        var _a;
        this.value2Text();
        var _b = this.props, className = _b.className, style = _b.style, onChange = _b.onChange, value = _b.value, defaultValue = _b.defaultValue, disabled = _b.disabled, children = _b.children, mode = _b.mode, size = _b.size, placeholder = _b.placeholder, otherProps = tslib_1.__rest(_b, ["className", "style", "onChange", "value", "defaultValue", "disabled", "children", "mode", "size", "placeholder"]);
        var preCls = 'yoshino-select';
        var visible = this.state.visible;
        var clsName = classNames(preCls, className, preCls + "-" + mode, " " + preCls + "-" + size, (_a = {},
            _a[preCls + "-hidden"] = !visible,
            _a[preCls + "-disabled"] = disabled,
            _a[preCls + "-enabled"] = !disabled,
            _a));
        var values = this.getValue();
        var list = (React.createElement(Expand, { timeout: this.timeout, active: visible },
            React.createElement("ul", null, React.Children.map(children, function (ele) {
                return React.cloneElement(ele, {
                    ctx: {
                        onChange: _this.onChange,
                        value: values,
                    }
                });
            }))));
        var isSingle = mode === 'single' || !Array.isArray(values);
        return (React.createElement(Pop, { content: list, placement: 'bottom', inheritWidth: true, trigger: 'focus', visible: !disabled, mouseLeaveDelay: 0, overlayClassName: preCls + "-list", onChange: function (v) {
                _this.toggleVisible(v);
            }, focusOnce: isSingle },
            React.createElement("div", tslib_1.__assign({ className: clsName, style: style, tabIndex: 0 }, otherProps),
                React.createElement("div", { className: preCls + "-selection" },
                    values.toString() === '' ? React.createElement("div", { className: preCls + "-placeholder" }, placeholder) : null,
                    mode === 'single' || !Array.isArray(values) ? (React.createElement("span", null, this.value2Text(values))) : (React.createElement("div", { className: preCls + "-container" }, values.map(function (item) {
                        var v = _this.value2Text(item);
                        return (React.createElement(Tag, { key: item + '', closeable: true, className: preCls + "-tag", onClose: function () {
                                // 执行tag动画
                                setTimeout(function () {
                                    _this.onChange(item);
                                }, 300);
                            } }, v));
                    }))),
                    React.createElement(Icon, { type: 'ios-arrow-up', className: preCls + "-icon" })))));
    };
    Select.defaultProps = {
        mode: 'single',
        size: 'default',
        defaultValue: '',
    };
    return Select;
}(Component));
export { Select };
Select.Option = Option;
Select.OptGroup = OptGroup;
export default Select;
//# sourceMappingURL=Select.js.map