import { Component } from 'react';
import * as React from 'react';
import { IBaseComponent } from '../template/component';
export interface ISliderProps extends IBaseComponent {
    /**
     * 滑块值 - 受控
     */
    value?: number;
    /**
     * 滑块值 - 非受控
     */
    defaultValue?: number;
    /**
     * 变化回调
     */
    onChange?: (value: number) => void;
    /**
     * 最大值
     */
    max?: number;
    /**
     * 最小值
     */
    min?: number;
    /**
     * 禁用
     */
    disabled?: boolean;
    /**
     * 步长
     */
    step?: number;
}
export interface ISliderDefaultProps extends IBaseComponent {
    defaultValue: number;
    max: number;
    min: number;
    disabled: boolean;
    step: number;
}
export interface ISliderState {
}
/**
 * **滑动输入条**-用于拖动选取当前值
 */
export declare class Slider extends Component<ISliderProps, ISliderState> {
    refSlider: HTMLElement;
    moving: boolean;
    static defaultProps: ISliderDefaultProps;
    state: {
        value: number;
    };
    getValue: () => number;
    getStepPercent: () => number;
    getPercent: () => number;
    onSliderClick: (e: React.MouseEvent<HTMLDivElement>) => void;
    onSliderMouseDown: () => void;
    onChangeTrigger: (value: number) => void;
    render(): JSX.Element;
}
export default Slider;
