import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
import Icon from '../Icon';
/**
 * **组件中文名称**-组件描述。
 */
var StepsItem = /** @class */ (function (_super) {
    tslib_1.__extends(StepsItem, _super);
    function StepsItem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StepsItem.prototype.render = function () {
        var _a;
        var _b = this.props, className = _b.className, style = _b.style, title = _b.title, direction = _b.direction, value = _b.value, size = _b.size, current = _b.current, status = _b.status, icon = _b.icon, children = _b.children, otherProps = tslib_1.__rest(_b, ["className", "style", "title", "direction", "value", "size", "current", "status", "icon", "children"]);
        var preCls = 'yoshino-steps-item';
        var clsName = classNames(preCls, preCls + "-" + size, (_a = {},
            _a[preCls + "-process"] = current === value,
            _a[preCls + "-wait"] = value > current,
            _a[preCls + "-error"] = status === 'error',
            _a), className);
        var stepIcon = {
            error: React.createElement(Icon, { type: 'md-close' }),
            finished: React.createElement(Icon, { type: 'md-checkmark' }),
        };
        var innerStatus = status ? status : value < current ? 'finished' : undefined;
        var text = value + 1;
        return (React.createElement("div", tslib_1.__assign({ className: clsName, style: style }, otherProps),
            React.createElement("div", { className: preCls + "-icon" },
                direction === 'vertical' ? React.createElement("div", { className: preCls + "-line-vertical" }) : null,
                icon ? icon : innerStatus ? stepIcon[innerStatus] : text),
            React.createElement("div", { className: preCls + "-content" },
                React.createElement("span", { className: preCls + "-title" }, title),
                children ? (React.createElement("p", { className: preCls + "-description" }, children)) : null)));
    };
    StepsItem.defaultProps = {};
    return StepsItem;
}(Component));
export { StepsItem };
export default StepsItem;
//# sourceMappingURL=StepsItem.js.map