import { Component } from 'react';
import * as React from 'react';
import { IBaseComponent } from '../template/component';
export declare type TSortOrder = boolean | 'ascend' | 'descend' | undefined;
export interface ITableProps extends IBaseComponent {
    data: any[];
    columns: IColumns[];
    fixedTitle?: boolean;
    scroll?: {
        x?: number | boolean;
        y: number;
    };
}
export interface IColumns {
    title: string;
    width?: number | string;
    dataIndex: string;
    fixed?: 'left' | 'right';
    style?: React.CSSProperties;
    render?: (v: any, item?: any) => void;
    sorter?: (a: any, b: any) => number;
    sortOrder?: TSortOrder;
    defaultSortOrder?: TSortOrder;
}
export interface ITableState {
    leftShadow: boolean;
    rightShadow: boolean;
    sortOrderObj: {
        [index: string]: TSortOrder;
    };
    sortField: string;
}
/**
 * **组件中文名称**-组件描述。
 */
export declare class Table extends Component<ITableProps, ITableState> {
    preCls: string;
    refScrollHeader: HTMLDivElement;
    refScrollBody: HTMLDivElement;
    lockHeaderAndBody: boolean | 'header' | 'body';
    unlockTime: number;
    timeoutlockHeaderAndBody: number;
    refFixedLeft: HTMLElement;
    refFixedRight: HTMLElement;
    lockFixedAndBody: boolean | 'left' | 'right' | 'body';
    timeoutlockFixedAndBody: number;
    state: {
        leftShadow: boolean;
        rightShadow: boolean;
        sortOrderObj: {
            [index: string]: TSortOrder;
        };
        sortField: string;
    };
    static defaultProps: {
        fixedTitle: boolean;
        scroll: {
            y: number;
            x: boolean;
        };
    };
    lockHeaderAndBodyFunc: (lock: "body" | "header") => void;
    lockFixedAndBodyFunc: (lock: "left" | "right" | "body") => void;
    scrollHeaderAndBodyEventListener: () => void;
    scrollBodyAndHeaderEventListener: () => void;
    scrollFixedLeftEventListener: () => void;
    scrollFixedRightEventListener: () => void;
    scrollBodyAndFixedEventListener: () => void;
    setFixedShadow: () => void;
    hasFixedLeft: () => boolean;
    hasFixedRight: () => boolean;
    componentDidMount(): void;
    componentWillUnmount(): void;
    renderColgroup: (columns: IColumns[]) => JSX.Element;
    renderThead: (columns: IColumns[]) => JSX.Element;
    renderTbody: (columns: IColumns[]) => JSX.Element;
    renderScrollHeader: () => JSX.Element;
    renderScrollBody: () => JSX.Element;
    renderFixedHeader: (columns: IColumns[]) => JSX.Element;
    renderFixedBody: (columns: IColumns[], pos: "left" | "right") => JSX.Element;
    render(): JSX.Element;
}
export default Table;
