import * as tslib_1 from "tslib";
// tslint:disable no-any
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
import Icon from '../Icon';
/**
 * **组件中文名称**-组件描述。
 */
var Table = /** @class */ (function (_super) {
    tslib_1.__extends(Table, _super);
    function Table() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.preCls = 'yoshino-table';
        // header与body滚动时的锁，如果其中一个滚动，另一个上锁，约定500ms后解锁
        _this.lockHeaderAndBody = false;
        _this.unlockTime = 500;
        _this.timeoutlockHeaderAndBody = 0;
        _this.lockFixedAndBody = false;
        _this.timeoutlockFixedAndBody = 0;
        _this.state = {
            leftShadow: false,
            rightShadow: false,
            sortOrderObj: (function () {
                var obj = {};
                _this.props.columns.forEach(function (item) {
                    var s = item.defaultSortOrder;
                    obj[item.dataIndex] = s;
                });
                return obj;
            })(),
            sortField: '',
        };
        _this.lockHeaderAndBodyFunc = function (lock) {
            _this.lockHeaderAndBody = lock;
            if (_this.timeoutlockHeaderAndBody) {
                clearTimeout(_this.timeoutlockHeaderAndBody);
            }
            _this.timeoutlockHeaderAndBody = window.setTimeout(function () {
                _this.lockHeaderAndBody = false; // 解锁
            }, _this.unlockTime);
        };
        _this.lockFixedAndBodyFunc = function (lock) {
            _this.lockFixedAndBody = lock;
            if (_this.timeoutlockFixedAndBody) {
                clearTimeout(_this.timeoutlockFixedAndBody);
            }
            _this.timeoutlockFixedAndBody = window.setTimeout(function () {
                _this.lockFixedAndBody = false; // 解锁
            }, _this.unlockTime);
        };
        // 滚动列表头部监听
        _this.scrollHeaderAndBodyEventListener = function () {
            if (_this.lockHeaderAndBody === 'body') {
                return;
            }
            _this.lockHeaderAndBodyFunc('header');
            _this.refScrollBody.scrollLeft = _this.refScrollHeader.scrollLeft;
        };
        // 滚动table主体监听
        _this.scrollBodyAndHeaderEventListener = function () {
            // 主体与header同步
            if (_this.lockHeaderAndBody === 'header') {
                return;
            }
            _this.lockHeaderAndBodyFunc('body');
            _this.refScrollHeader.scrollLeft = _this.refScrollBody.scrollLeft;
        };
        // 左侧锁列监听
        _this.scrollFixedLeftEventListener = function () {
            var lock = _this.lockFixedAndBody;
            if (lock !== false && lock !== 'left') {
                return;
            }
            _this.lockFixedAndBodyFunc('left');
            var top = _this.refFixedLeft.scrollTop;
            _this.refScrollBody.scrollTop = top;
            if (_this.hasFixedRight) {
                _this.refFixedRight.scrollTop = top;
            }
        };
        // 右侧锁列监听
        _this.scrollFixedRightEventListener = function () {
            var lock = _this.lockFixedAndBody;
            if (lock !== false && lock !== 'right') {
                return;
            }
            _this.lockFixedAndBodyFunc('right');
            var top = _this.refFixedRight.scrollTop;
            _this.refScrollBody.scrollTop = top;
            if (_this.hasFixedLeft) {
                _this.refFixedLeft.scrollTop = top;
            }
        };
        // 主体与锁列同步
        _this.scrollBodyAndFixedEventListener = function () {
            _this.setFixedShadow();
            var dom = _this.refScrollBody;
            var lock = _this.lockFixedAndBody;
            if (lock !== false && lock !== 'body') {
                return;
            }
            _this.lockFixedAndBodyFunc('body');
            var top = dom.scrollTop;
            if (_this.hasFixedRight) {
                _this.refFixedRight.scrollTop = top;
            }
            if (_this.hasFixedLeft) {
                _this.refFixedLeft.scrollTop = top;
            }
        };
        // 设置shadow显示
        _this.setFixedShadow = function () {
            var dom = _this.refScrollBody;
            if (dom.scrollLeft > 0 && _this.hasFixedLeft()) {
                if (!_this.state.leftShadow) {
                    _this.setState({ leftShadow: true });
                }
            }
            else {
                if (_this.state.leftShadow) {
                    _this.setState({ leftShadow: false });
                }
            }
            if (dom.scrollLeft === dom.scrollWidth - dom.clientWidth) {
                if (_this.state.rightShadow) {
                    _this.setState({ rightShadow: false });
                }
            }
            else {
                if (!_this.state.rightShadow) {
                    _this.setState({ rightShadow: true });
                }
            }
        };
        // 是否左侧锁列
        _this.hasFixedLeft = function () {
            return !!_this.props.columns.filter(function (item) { return item.fixed === 'left'; }).length;
        };
        // 是否右侧锁列
        _this.hasFixedRight = function () {
            return !!_this.props.columns.filter(function (item) { return item.fixed === 'right'; }).length;
        };
        _this.renderColgroup = function (columns) {
            return (React.createElement("colgroup", null, columns.map(function (item, key) { return (React.createElement("col", { key: key, style: { width: item.width } })); })));
        };
        _this.renderThead = function (columns) {
            return (React.createElement("thead", null,
                React.createElement("tr", null, columns.map(function (item, key) {
                    var _a, _b, _c;
                    var sortField = _this.state.sortField;
                    var temp = JSON.parse(JSON.stringify(_this.state.sortOrderObj));
                    var defaultSortOder = temp[item.dataIndex];
                    var showSort = item.sorter !== undefined;
                    var isCurrentField = item.dataIndex === sortField;
                    var cls = _this.preCls + "-sorter-active";
                    var upCls = classNames((_a = {},
                        _a["" + cls] = (item.sortOrder === 'ascend' || defaultSortOder === 'ascend') && showSort && isCurrentField,
                        _a));
                    var downCls = classNames((_b = {},
                        _b["" + cls] = (item.sortOrder === 'descend' || defaultSortOder === 'descend') && showSort && isCurrentField,
                        _b));
                    if (sortField === '' && item.defaultSortOrder !== undefined) {
                        _this.setState({ sortField: item.dataIndex });
                    }
                    var thCls = classNames((_c = {},
                        _c[_this.preCls + "-th-sorter"] = showSort,
                        _c));
                    return (React.createElement("th", { className: thCls, key: key, onClick: function () {
                            if (!showSort) {
                                return;
                            }
                            var currentSort = defaultSortOder;
                            // 点击后全部排序顺序重置
                            for (var key_1 in temp) {
                                if (temp.hasOwnProperty(key_1)) {
                                    temp[key_1] = false;
                                }
                            }
                            if (currentSort === 'ascend') {
                                temp[item.dataIndex] = 'descend';
                            }
                            else if (currentSort === 'descend') {
                                temp[item.dataIndex] = false;
                            }
                            else {
                                temp[item.dataIndex] = 'ascend';
                            }
                            _this.setState({ sortField: item.dataIndex, sortOrderObj: temp });
                        } },
                        item.title,
                        showSort ? (React.createElement("div", { className: _this.preCls + "-sorter" },
                            React.createElement(Icon, { className: upCls, type: 'md-arrow-dropup' }),
                            React.createElement(Icon, { className: downCls, type: 'md-arrow-dropdown' }))) : null));
                }))));
        };
        _this.renderTbody = function (columns) {
            var data = _this.props.data;
            var temp = [];
            var _loop_1 = function (i) {
                var col = columns[i];
                if (col.dataIndex === _this.state.sortField) {
                    var sort_1 = col.sorter;
                    var sortOrder_1 = col.sortOrder !== undefined ? col.sortOrder : _this.state.sortOrderObj[col.dataIndex];
                    if (typeof sortOrder_1 === 'string') {
                        temp = JSON.parse(JSON.stringify(data)).sort(function (a, b) {
                            var pre = a[col.dataIndex];
                            var next = b[col.dataIndex];
                            var result = sort_1(pre, next);
                            if (sortOrder_1 === 'descend') {
                                result = -result;
                            }
                            return result;
                        });
                    }
                }
            };
            for (var i = 0; i < columns.length; i++) {
                _loop_1(i);
            }
            var content = (temp.length ? temp : data).map(function (item, key) {
                return (React.createElement("tr", { key: key }, columns.map(function (column, index) {
                    var v = item[column.dataIndex];
                    return (React.createElement("td", { key: index }, column.render ? column.render(v, item) : v));
                })));
            });
            return (React.createElement("tbody", null, content));
        };
        _this.renderScrollHeader = function () {
            var _a = _this.props, columns = _a.columns, fixedTitle = _a.fixedTitle, scroll = _a.scroll;
            var scrollX = scroll.x;
            var width = typeof scrollX === 'boolean' && scrollX ? undefined : scrollX ? scrollX : undefined;
            var style = fixedTitle ? {
                minWidth: width,
            } : {};
            return (React.createElement("table", { style: style },
                _this.renderColgroup(columns),
                _this.renderThead(columns)));
        };
        _this.renderScrollBody = function () {
            var _a = _this.props, columns = _a.columns, fixedTitle = _a.fixedTitle, scroll = _a.scroll;
            var scrollX = scroll.x;
            var width = typeof scrollX === 'boolean' && scrollX ? undefined : scrollX ? scrollX : undefined;
            var style = fixedTitle ? {
                minWidth: width,
            } : {};
            return (React.createElement("table", { style: style },
                _this.renderColgroup(columns),
                fixedTitle ? null : _this.renderThead(columns),
                _this.renderTbody(columns)));
        };
        _this.renderFixedHeader = function (columns) {
            return (React.createElement("div", { className: _this.preCls + "-header-inner" },
                React.createElement("table", null,
                    _this.renderColgroup(columns),
                    _this.renderThead(columns))));
        };
        _this.renderFixedBody = function (columns, pos) {
            var _a = _this.props, fixedTitle = _a.fixedTitle, scroll = _a.scroll;
            var bodyStyle = fixedTitle ? {
                maxHeight: scroll.y,
            } : {};
            return (React.createElement("div", { className: _this.preCls + "-body-inner", style: bodyStyle, ref: function (v) {
                    if (!v) {
                        return;
                    }
                    if (pos === 'left') {
                        _this.refFixedLeft = v;
                    }
                    else if (pos === 'right') {
                        _this.refFixedRight = v;
                    }
                } },
                React.createElement("table", null,
                    _this.renderColgroup(columns),
                    fixedTitle ? null : _this.renderThead(columns),
                    _this.renderTbody(columns))));
        };
        return _this;
    }
    Table.prototype.componentDidMount = function () {
        var fixedTitle = this.props.fixedTitle;
        var isFixedLeft = this.hasFixedLeft();
        var isFixedRight = this.hasFixedRight();
        if (fixedTitle) {
            this.refScrollBody.addEventListener('scroll', this.scrollBodyAndHeaderEventListener);
            this.refScrollHeader.addEventListener('scroll', this.scrollHeaderAndBodyEventListener);
        }
        if (isFixedLeft || isFixedRight) {
            this.refScrollBody.addEventListener('scroll', this.scrollBodyAndFixedEventListener);
        }
        if (isFixedLeft) {
            this.refFixedLeft.addEventListener('scroll', this.scrollFixedLeftEventListener);
        }
        if (isFixedRight) {
            this.refFixedRight.addEventListener('scroll', this.scrollFixedRightEventListener);
        }
        this.setFixedShadow();
    };
    Table.prototype.componentWillUnmount = function () {
        var fixedTitle = this.props.fixedTitle;
        var isFixedLeft = this.hasFixedLeft();
        var isFixedRight = this.hasFixedRight();
        if (fixedTitle) {
            this.refScrollBody.removeEventListener('scroll', this.scrollBodyAndHeaderEventListener);
            this.refScrollHeader.removeEventListener('scroll', this.scrollHeaderAndBodyEventListener);
        }
        if (isFixedLeft || isFixedRight) {
            this.refScrollBody.removeEventListener('scroll', this.scrollBodyAndFixedEventListener);
        }
        if (isFixedLeft) {
            this.refFixedLeft.removeEventListener('scroll', this.scrollFixedLeftEventListener);
        }
        if (isFixedRight) {
            this.refFixedRight.removeEventListener('scroll', this.scrollFixedRightEventListener);
        }
    };
    Table.prototype.render = function () {
        var _this = this;
        var _a, _b, _c;
        var _d = this.props, className = _d.className, style = _d.style, columns = _d.columns, data = _d.data, fixedTitle = _d.fixedTitle, scroll = _d.scroll, otherProps = tslib_1.__rest(_d, ["className", "style", "columns", "data", "fixedTitle", "scroll"]);
        var preCls = this.preCls;
        var clsName = classNames(preCls, className, (_a = {}, _a[preCls + "-fixed-header"] = fixedTitle, _a));
        var bodyStyle = fixedTitle ? {
            maxHeight: scroll.y,
        } : {};
        var fixedLeftCol = columns.filter(function (item) { return item.fixed === 'left'; });
        var fixedRightCol = columns.filter(function (item) { return item.fixed === 'right'; });
        var fixedLeftCls = classNames(preCls + "-fixed-left", (_b = {}, _b[preCls + "-fixed-left-shadow"] = this.state.leftShadow, _b));
        var fixedRightCls = classNames(preCls + "-fixed-right", (_c = {}, _c[preCls + "-fixed-right-shadow"] = this.state.rightShadow, _c));
        return (React.createElement("div", tslib_1.__assign({ className: clsName, style: style }, otherProps),
            React.createElement("div", { className: preCls + "-content" },
                React.createElement("div", { className: preCls + "-scroll" },
                    fixedTitle ? (React.createElement("div", { className: preCls + "-header", ref: function (v) {
                            if (v) {
                                _this.refScrollHeader = v;
                            }
                        } }, this.renderScrollHeader())) : null,
                    React.createElement("div", { className: preCls + "-body", style: bodyStyle, ref: function (v) {
                            if (v) {
                                _this.refScrollBody = v;
                            }
                        } }, this.renderScrollBody())),
                fixedLeftCol.length ? (React.createElement("div", { className: fixedLeftCls },
                    React.createElement("div", { className: preCls + "-header-outter" }, this.renderFixedHeader(fixedLeftCol)),
                    React.createElement("div", { className: preCls + "-body-outter" }, this.renderFixedBody(fixedLeftCol, 'left')))) : null,
                fixedRightCol.length ? (React.createElement("div", { className: fixedRightCls },
                    React.createElement("div", { className: preCls + "-header-ouuter" }, this.renderFixedHeader(fixedRightCol)),
                    React.createElement("div", { className: preCls + "-body-outter" }, this.renderFixedBody(fixedRightCol, 'right')))) : null)));
    };
    Table.defaultProps = {
        fixedTitle: false,
        scroll: {
            y: 280,
            x: true,
        },
    };
    return Table;
}(Component));
export { Table };
export default Table;
//# sourceMappingURL=Table.js.map