import * as tslib_1 from "tslib";
import * as React from 'react';
import * as classNames from 'classnames';
import * as moment from 'moment';
import Icon from '../Icon';
import { valueTransition } from '../utils/';
var TimePanel = /** @class */ (function (_super) {
    tslib_1.__extends(TimePanel, _super);
    function TimePanel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.preCls = 'yoshino-time-picker';
        _this.onChange = function (value) {
            var onChange = _this.props.onChange;
            onChange(value);
        };
        _this.renderSelectItem = function (type) {
            var values = [];
            var selectedItem = 0;
            var _a = _this.props, format = _a.format, value = _a.value;
            var v = value;
            var m = moment(v, format);
            var fillValues = function (max) {
                for (var i = 0; i <= max; i++) {
                    var v_1 = i < 10 ? "0" + i : (i + '');
                    values.push(v_1);
                }
            };
            var typeAction = {
                h: function () {
                    selectedItem = m.hour();
                    fillValues(23);
                },
                m: function () {
                    selectedItem = m.minute();
                    fillValues(59);
                },
                s: function () {
                    selectedItem = m.second();
                    fillValues(59);
                }
            };
            typeAction[type]();
            return (React.createElement("div", { className: _this.preCls + "-select-item", ref: function (v) {
                    if (v) {
                        var typeAction_1 = {
                            h: function () { return _this.refHourDiv = v; },
                            m: function () { return _this.refMinuteDiv = v; },
                            s: function () { return _this.refSecondDiv = v; },
                        };
                        typeAction_1[type]();
                    }
                } },
                React.createElement("ul", null, values.map(function (item, key) {
                    var _a;
                    var v = Number(item);
                    var isActive = v === selectedItem;
                    var cls = classNames((_a = {},
                        _a[_this.preCls + "-select-item-selected"] = isActive,
                        _a));
                    return (React.createElement("li", { className: cls, key: key, onClick: function (e) {
                            if (_this.refPanelInput) {
                                _this.refPanelInput.focus();
                            }
                            var format = _this.props.format;
                            var time = Number(item);
                            var v = value;
                            var m = v ? moment(v, format) : moment();
                            var typeAction = {
                                h: function () { return m.hour(time); },
                                m: function () { return m.minute(time); },
                                s: function () { return m.second(time); },
                            };
                            m = typeAction[type]();
                            _this.onChange(m.format(format));
                            // tslint:disable-next-line
                            var offsetTop = e.target.offsetTop;
                            var syncScrollTop = function (dom) {
                                var start = dom.scrollTop;
                                var end = offsetTop;
                                valueTransition({
                                    start: start, end: end,
                                }, function (v) {
                                    dom.scrollTop = v;
                                });
                            };
                            var scrollTypeAction = {
                                h: function () { return syncScrollTop(_this.refHourDiv); },
                                m: function () { return syncScrollTop(_this.refMinuteDiv); },
                                s: function () { return syncScrollTop(_this.refSecondDiv); },
                            };
                            setTimeout(scrollTypeAction[type], 0);
                        }, ref: function (v) {
                            if (v && isActive) {
                                var offsetTop_1 = v.offsetTop;
                                var syncScrollTop_1 = function (dom) {
                                    dom.scrollTop = offsetTop_1;
                                };
                                var scrollTypeAction = {
                                    h: function () { return syncScrollTop_1(_this.refHourDiv); },
                                    m: function () { return syncScrollTop_1(_this.refMinuteDiv); },
                                    s: function () { return syncScrollTop_1(_this.refSecondDiv); },
                                };
                                setTimeout(scrollTypeAction[type], 0);
                            }
                        } }, item));
                }))));
        };
        return _this;
    }
    TimePanel.prototype.render = function () {
        var _this = this;
        var _a = this.props, placeholder = _a.placeholder, disabledHours = _a.disabledHours, disabledMinutes = _a.disabledMinutes, disabledSeconds = _a.disabledSeconds, value = _a.value;
        var preCls = this.preCls;
        return (React.createElement("div", { className: preCls + "-panel" },
            React.createElement("div", { className: preCls + "-input-wrap" },
                React.createElement("input", { placeholder: placeholder, readOnly: true, value: value, ref: function (v) {
                        if (v) {
                            _this.refPanelInput = v;
                        }
                    } }),
                React.createElement(Icon, { type: 'ios-close-circle', onClick: this.onChange.bind(this, '') })),
            React.createElement("div", { className: preCls + "-select-container" },
                disabledHours ? null : this.renderSelectItem('h'),
                disabledMinutes ? null : this.renderSelectItem('m'),
                disabledSeconds ? null : this.renderSelectItem('s'))));
    };
    TimePanel.defaultProps = {
        format: 'HH:mm:ss'
    };
    return TimePanel;
}(React.Component));
export default TimePanel;
//# sourceMappingURL=TimePanel.js.map