import { Component } from 'react';
import { IBaseComponent, TSize } from '../template/component';
export interface ITimePickerProps extends IBaseComponent {
    /**
     * 默认提示文本
     */
    placeholder?: string;
    /**
     * 默认值
     */
    defaultValue?: string;
    /**
     * 值
     */
    value?: string;
    /**
     * 禁用
     */
    disabled?: boolean;
    /**
     * 值变化回调
     */
    onChange?: (v: string) => void;
    /**
     * 面板是否展开 - 受控
     */
    open?: boolean;
    /**
     * 面板是否展开 - 非受控
     */
    defaultOpen?: boolean;
    /**
     * 面板展开回调
     */
    onOpenChange?: (v: boolean) => void;
    /**
     * 尺寸
     */
    size?: TSize;
    /**
     * 禁用时、分、秒部分选项
     */
    disabledHours?: boolean;
    disabledMinutes?: boolean;
    disabledSeconds?: boolean;
    /**
     * 展示时间格式
     */
    format?: string;
}
export interface ITimePickerState {
    open: boolean;
    value: string;
}
/**
 * **组件中文名称**-组件描述。
 */
export declare class TimePicker extends Component<ITimePickerProps, ITimePickerState> {
    preCls: string;
    refTimePickerConatainer?: HTMLDivElement;
    refPanelInput?: HTMLInputElement;
    timeoutHandle?: number;
    refHourDiv: HTMLDivElement;
    refHourLi: HTMLLIElement;
    refMinuteDiv: HTMLDivElement;
    refMinuteLi: HTMLLIElement;
    refSecondDiv: HTMLDivElement;
    refSecondLi: HTMLLIElement;
    static defaultProps: {
        size: string;
        placeholder: string;
        disabledHours: boolean;
        disabledMinutes: boolean;
        disabledSeconds: boolean;
        defaultOpen: boolean;
        defaultValue: string;
        format: string;
    };
    state: {
        panelPos: {
            left: number;
            top: number;
        };
        open: boolean;
        value: string;
    };
    getOpen: () => boolean;
    getValue: () => string;
    onOpenChange: (open: boolean) => void;
    onChange: (value: string) => void;
    render(): JSX.Element;
}
export default TimePicker;
