import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
import Input from '../Input';
import Icon from '../Icon';
import Popover from '../PopOver';
import TimePanel from './TimePanel';
/**
 * **组件中文名称**-组件描述。
 */
var TimePicker = /** @class */ (function (_super) {
    tslib_1.__extends(TimePicker, _super);
    function TimePicker() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.preCls = 'yoshino-time-picker';
        _this.state = {
            panelPos: {
                left: 0,
                top: 0,
            },
            open: _this.props.defaultOpen,
            value: _this.props.defaultValue,
        };
        _this.getOpen = function () {
            var open = _this.props.open;
            return open !== undefined ? open : _this.state.open;
        };
        _this.getValue = function () {
            var value = _this.props.value;
            return value !== undefined ? value : _this.state.value;
        };
        _this.onOpenChange = function (open) {
            var _a = _this.props, onOpenChange = _a.onOpenChange, disabled = _a.disabled;
            if (disabled) {
                return;
            }
            if (_this.timeoutHandle !== undefined) {
                clearTimeout(_this.timeoutHandle);
            }
            _this.timeoutHandle = window.setTimeout(function () {
                if (onOpenChange) {
                    onOpenChange(open);
                }
                _this.setState({
                    open: open,
                });
            }, 10);
        };
        _this.onChange = function (value) {
            var onChange = _this.props.onChange;
            if (onChange) {
                onChange(value);
            }
            _this.setState({
                value: value,
            });
        };
        return _this;
    }
    TimePicker.prototype.render = function () {
        var _a = this.props, className = _a.className, style = _a.style, defaultValue = _a.defaultValue, value = _a.value, onChange = _a.onChange, open = _a.open, defaultOpen = _a.defaultOpen, onOpenChange = _a.onOpenChange, disabled = _a.disabled, placeholder = _a.placeholder, size = _a.size, disabledHours = _a.disabledHours, disabledMinutes = _a.disabledMinutes, disabledSeconds = _a.disabledSeconds, format = _a.format, otherProps = tslib_1.__rest(_a, ["className", "style", "defaultValue", "value", "onChange", "open", "defaultOpen", "onOpenChange", "disabled", "placeholder", "size", "disabledHours", "disabledMinutes", "disabledSeconds", "format"]);
        var preCls = this.preCls;
        var clsName = classNames(preCls, className, preCls + "-size-" + size);
        var valueR = this.getValue();
        var openR = this.getOpen();
        var pop = (React.createElement("div", null,
            React.createElement(TimePanel, { value: valueR, placeholder: placeholder, onChange: this.onChange, format: format, disabledHours: disabledHours, disabledMinutes: disabledMinutes, disabledSeconds: disabledSeconds })));
        return (React.createElement(Popover, { pop: pop, unmountOnExit: false, open: openR, onOpenChange: this.onOpenChange },
            React.createElement("div", tslib_1.__assign({ className: clsName, style: style }, otherProps),
                React.createElement(Input, { size: size, disabled: disabled, placeholder: placeholder, onClick: this.onOpenChange.bind(this, true), value: valueR, readOnly: true }),
                React.createElement(Icon, { className: preCls + "-icon", type: 'md-time' }))));
    };
    TimePicker.defaultProps = {
        size: 'default',
        placeholder: '请选择时间',
        disabledHours: false,
        disabledMinutes: false,
        disabledSeconds: false,
        defaultOpen: false,
        defaultValue: '',
        format: 'HH:mm:ss',
    };
    return TimePicker;
}(Component));
export { TimePicker };
export default TimePicker;
//# sourceMappingURL=TimePicker.js.map