import { Component } from 'react';
import { ITransitions } from '../template/component';
export interface ISlideProps extends ITransitions {
    /**
     * 动画时间 ms
     */
    timeout?: number;
    /**
     * 激活状态
     */
    active: boolean;
    /**
     * 方向
     */
    direction: 'left' | 'top' | 'right' | 'bottom';
    /**
     * single 是否单方向滑动
     */
    single?: boolean;
    /**
     * 是否关闭透明度变化
     */
    opacity?: boolean;
    /**
     * 首次进入是否加载动画
     */
    appear?: boolean;
}
export interface ISlideState {
}
/**
 * **组件中文名称**-组件描述。
 */
export declare class Slide extends Component<ISlideProps, ISlideState> {
    refChild: HTMLElement;
    static defaultProps: {
        timeout: number;
        single: boolean;
        opacity: boolean;
        appear: boolean;
        mountOnEnter: boolean;
        unmountOnExit: boolean;
    };
    render(): JSX.Element;
}
export default Slide;
