import * as tslib_1 from "tslib";
import { Component } from 'react';
import { unmountComponentAtNode, render } from 'react-dom';
// 根节点渲染HOC
var RenderInRootDom = /** @class */ (function (_super) {
    tslib_1.__extends(RenderInRootDom, _super);
    function RenderInRootDom() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.renderFlag = false; // 判断是否已经渲染过
        _this.renderChild = function () {
            var _a = _this.props, boxClass = _a.boxClass, zIndex = _a.zIndex;
            _this.box = document.createElement("div");
            if (boxClass) {
                _this.box.setAttribute('class', boxClass);
            }
            _this.box.style.position = 'absolute';
            _this.box.style.zIndex = zIndex + '';
            _this.box.style.left = '0';
            _this.box.style.top = '0';
            document.body.appendChild(_this.box);
            _this._renderLayer();
        };
        return _this;
    }
    // 在根节点下渲染children
    RenderInRootDom.prototype.componentDidMount = function () {
        var mount = this.props.mount;
        if (mount) {
            this.renderFlag = true;
            this.renderChild();
        }
    };
    // 节点更新
    RenderInRootDom.prototype.componentDidUpdate = function () {
        var mount = this.props.mount;
        if (mount && !this.renderFlag) {
            this.renderFlag = true;
            this.renderChild();
        }
        else {
            this._renderLayer();
        }
    };
    // 组件卸载时移除渲染节点
    RenderInRootDom.prototype.componentWillUnmount = function () {
        if (this.renderFlag) {
            unmountComponentAtNode(this.box);
            document.body.removeChild(this.box);
        }
    };
    // 渲染方法
    RenderInRootDom.prototype._renderLayer = function () {
        if (this.renderFlag) {
            render(this.props.children, this.box, this.props.callBack);
        }
    };
    RenderInRootDom.prototype.render = function () {
        return null;
    };
    RenderInRootDom.defaultProps = {
        mount: true,
        zIndex: 1000,
    };
    return RenderInRootDom;
}(Component));
export { RenderInRootDom };
//# sourceMappingURL=renderInRootDom.js.map